#define WIDTHBYTES(bits)	((((bits) + 31)>>5)<<2)

//LPBYTE	FindDIBBits( LPBITMAPINFOHEADER lpbih );
WORD	BmiSize(LPBITMAPINFOHEADER lpbih);
WORD	BitMaskSize(LPBITMAPINFOHEADER lpbih);
WORD	PaletteSize( LPBITMAPINFOHEADER lpbih );
WORD	DIBNumColors( LPBITMAPINFOHEADER lpbih );
DWORD	BytesPerLine( LPBITMAPINFOHEADER lpbih );
DWORD	BytesPerLine( DWORD dwWidth, DWORD dwBpp );

/*
// DIB ̃sNZf[^̐擪AhXԂ
LPBYTE FindDIBBits( LPBITMAPINFOHEADER lpbih )
{
	return ((LPBYTE) lpbih + *(LPDWORD)lpbih + PaletteSize( lpbih ));
}// FindDIBBits
*/
// DIB  BITMAPINFO \̃TCYԂ
WORD BmiSize(LPBITMAPINFOHEADER lpbih)
{
	return (sizeof(BITMAPINFOHEADER) + BitMaskSize(lpbih) + PaletteSize(lpbih));
}// BmiMaskSize

// DIB ̃sNZtH[}bg TCYԂ
WORD BitMaskSize(LPBITMAPINFOHEADER lpbih)
{
	WORD mask_size = 0;
	if(lpbih->biCompression == BI_BITFIELDS)
		mask_size = sizeof(DWORD) * 3;
	return mask_size;
}// BitMaskSize

// DIB ̃pbg̃TCYԂ
WORD PaletteSize( LPBITMAPINFOHEADER lpbih )
{
	return ( DIBNumColors( lpbih ) * sizeof( RGBQUAD ) );
}// PaletteSize

// DIB ̐FԂ
WORD DIBNumColors( LPBITMAPINFOHEADER lpbih )
{
	int num;
	if(lpbih->biBitCount > 8)
		num = 0;
	else if(lpbih->biClrUsed == 0)
		num = 1 << lpbih->biBitCount;
	else
		num = lpbih->biClrUsed;
	return num;
}// DIBNumColors

// DIB  4byte EԂ
DWORD BytesPerLine( LPBITMAPINFOHEADER lpbih )
{
	return WIDTHBYTES(lpbih->biWidth * lpbih->biPlanes * lpbih->biBitCount);
}// BytesPerLine

// 摜̕ƐF[xw肵 4byte EԂ
DWORD BytesPerLine( DWORD dwWidth, DWORD dwBpp )
{
	return WIDTHBYTES(dwWidth * dwBpp);
}// BytesPerLine
