#define PICKUP_NUM		1024	// Index_256Try_Get_PixelgĉF܂ŊԈɎoH

ColorPalette *g_ppal = NULL;

typedef struct{
	WORD	Val;
	WORD	Num;
}DATA,*LPDATA;

typedef struct{
	BYTE	min[3],max[3],len[3];
	int		data_len;
	DATA	*pData;
}MEDIAN,*LPMEDIAN;

MEDIAN	g_mdn[256];

Status	Index_1(Bitmap *Bmp_R, Bitmap *Bmp_W, float rate, bool flag_Dither);
Status	Index_256_Fix(Bitmap *Bmp_R, Bitmap *Bmp_W, UINT kks, bool flag_Dither);
void 	Set_FixPal(ColorPalette *ppal, int nColors);
void	Create_8bit_FixedPal(PALETTEENTRY *pe);
Status	Index_256_Gray(Bitmap *Bmp_R, Bitmap *Bmp_W, bool flag_Dither);
Status	Index_256(Bitmap *Bmp_R, Bitmap *Bmp_W, UINT kkx, UINT kky, UINT kks, bool flag_Dither, bool flag_Alpha);
Status	Index_256_Med(Bitmap *Bmp_R, Bitmap *Bmp_W, bool flag_Dither, bool flag_Alpha);
void	Set_MdnInfo(int index);
int		Select_Color(BYTE *pixels, int pos, BRGB *bRGB, UINT nColors);
int		DWORDcmp(const DWORD *a, const DWORD *b);
int		DWORDcmp2(const DWORD *a, const DWORD *b);
int		DATAcmpR(const DATA *a, const DATA *b);
int		DATAcmpG(const DATA *a, const DATA *b);
int		DATAcmpB(const DATA *a, const DATA *b);
WORD	Try_Get_Pixel(BYTE *pixels1, BARGB *bARGB1, UINT wdh, UINT hgt, UINT stride1, UINT numClrs);
void	Try_Get_Pixel_Sub(DWORD ct, UINT pos, BYTE *pixels1, BARGB *bARGB1);
DWORD	Get_Pixel(UINT kkx, UINT kky, BYTE *pixels1, BRGB *bRGB1, UINT wdh, UINT hgt, UINT stride1, int *bRng);
void	Get_Pixel_Sub(DWORD ct, BYTE *pxl, BRGB *bRGB1, BRGB *bMin, BRGB *bMax);
void	Get_Pixel_Sub2(BRGB *bRGB1, BRGB *bMin, BRGB *bMax);
DWORD	Get_Pixel_All(BYTE *pixels1, DATA *pData, UINT wdh, UINT hgt, UINT stride1);
void	Dithering(UINT x, UINT y, UINT wdh, UINT hgt, UINT stride1, BYTE *pixels, BRGB bRgb);
void	Dithering_Sub(int gv, int pos2, BYTE *pixels, IRGB gk);
void	Set_IdxClrPx(int bpp, BYTE *pixels, UINT stride, int x, int y, int val);

// Fpbgϊ
// rate : x̋E䗦(0 ` 1.0f)
Status Index_1(Bitmap *Bmp_R, Bitmap *Bmp_W, float rate, bool flag_Dither)
{
	Status		st = GenericError;
	BYTE		BrtBorder;			// x̋El
	BYTE		BrtMax,BrtMin;		// ŖxƍňÓx
	BYTE		*pixels2 = NULL;	// ǂݍ݃f[^̃Rs[
	UINT		stride1;			// ǂݍ݃f[^4byteE
	BitmapData	bitmapData;
	UINT		wdh = Bmp_R->GetWidth();
	UINT		hgt = Bmp_R->GetHeight();
	Rect		rect(0, 0, wdh, hgt);
	UINT		nColors = 0;	// F
	BRGB		bRgb[2];		// pbgRGB
	UINT		i;
	
	PixelFormat	fmt	= Bmp_W->GetPixelFormat();
	UINT		bpp	= (BYTE)(fmt >> 8);	// F[x
	
	if(!(fmt & PixelFormat1bppIndexed)){
		MessageBox (GetFocus(),"o̓tH[}bg1bitpbgJ[ł͂܂","",MB_OK);
		return GenericError;
	}
	
	if(bpp == 1){
		nColors = 2;		// pbg̍őF
	}
	else{
		MessageBox (GetFocus(),"2F݂̂ɑΉĂ܂","",MB_OK);
		return st;
	}
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	// rbg̓ǂݍ
	st = Bmp_R->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels1 = NULL;	// 32bppFf
		
		if (bitmapData.Stride > 0)
			pixels1 = (BYTE*) bitmapData.Scan0;
		else
			pixels1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		BYTE	brt;				// x
		UINT	x,y,pos1;
		
		brt = (pixels1[0] + pixels1[1] + pixels1[2]) / 3;
		BrtMax = BrtMin = brt;
		
		for(y=0; y<hgt; y++){
			for(x=1; x<wdh; x++){
				pos1 = y*stride1+x*4;
				brt = (pixels1[pos1+0] + pixels1[pos1+1] + pixels1[pos1+2]) / 3;
				if(brt > BrtMax){
					BrtMax = brt;
				}
				else if(brt < BrtMin){
					BrtMin = brt;
				}
			}
		}
		
		if(rate > 1){
			rate = 1;
		}
		else if(rate < 0){
			rate = 0;
		}
		
		BrtBorder = (BYTE)(BrtMax * rate + BrtMin * (1 - rate));
		
		pixels2 = new BYTE [stride1*hgt];
		
		// pixels1pixels2ɃRs[
		memcpy(pixels2, pixels1, stride1*hgt*sizeof(BYTE));
		
		st = Bmp_R->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
			SAFE_DELETE_ARRAY(pixels2);
			SetCursor(hCurPre);
			return st;
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
		SetCursor(hCurPre);
		return st;
	}
	
	DWORD	dwSizeColorPalette = sizeof(ColorPalette) + sizeof(ARGB)*(nColors-1);
	
	ColorPalette *ppal = (ColorPalette *)new BYTE[dwSizeColorPalette];
	if (ppal == NULL){
		MessageBox (GetFocus(), "sĂ܂", "", MB_OK);
		SAFE_DELETE_ARRAY(pixels2);
		SetCursor(hCurPre);
		return OutOfMemory;
	}
	
	ZeroMemory(ppal, dwSizeColorPalette);
	
	ARGB pal_2[2] = {0xff000000, 0xffffffff};
	ppal->Flags = 0;
	ppal->Count = nColors;
	for (i=0; i<nColors; i++){
		Color clr(pal_2[i]);
		ppal->Entries[i] = clr.GetValue();
		bRgb[i].B = (BYTE) ppal->Entries[i];
		bRgb[i].G = (BYTE)(ppal->Entries[i] >> 8);
		bRgb[i].R = (BYTE)(ppal->Entries[i] >> 16);
	}
	
	st = Bmp_W->SetPalette(ppal);
	if (st != Ok)
	{
		MessageBox (GetFocus(),"pbg쐬ł܂","",MB_OK);
		SAFE_DELETE_ARRAY_BYTE(ppal);
		SAFE_DELETE_ARRAY(pixels2);
		SetCursor(hCurPre);
		return st;
	}
	
	// rbgBmp_WɃZbg
	st = Bmp_W->LockBits(&rect, ImageLockModeWrite, fmt, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels = NULL,brt;
		int 	pos1,p_num;
		UINT	x,y;
		
		if (bitmapData.Stride > 0)
			pixels = (BYTE*) bitmapData.Scan0;
		else
			pixels = (BYTE*) bitmapData.Scan0 + bitmapData.Stride*(hgt-1);
		
		UINT stride = abs(bitmapData.Stride);
		
		// esNZ̋ߎFpbgTAFԍ
		for(y=0; y<hgt; y++){
			for(x=0; x<wdh; x++){
				pos1 = y*stride1+x*4;
				brt = (pixels2[pos1+0] + pixels2[pos1+1] + pixels2[pos1+2]) / 3;
				if(BrtMin != BrtMax){
					if(brt <= BrtBorder)
						p_num = 0;
					else
						p_num = 1;
				}
				else{
					if(brt >= (int)(255 * rate))
						p_num = 0;
					else
						p_num = 1;
				}
				Set_IdxClrPx(bpp, pixels, stride, x, y, p_num);
				// fBU
				if(flag_Dither)
					Dithering(x, y, wdh, hgt, stride1, pixels2, bRgb[p_num]);
			}
		}
		st = Bmp_W->UnlockBits(&bitmapData);
		if (st != Ok){
			MessageBox (GetFocus(),"BmpAbNł܂","",MB_OK);
		}
	}
	else{
		MessageBox (GetFocus(),"BmpbNł܂","",MB_OK);
	}
	SAFE_DELETE_ARRAY_BYTE(ppal);
	SAFE_DELETE_ARRAY(pixels2);
	SetCursor(hCurPre);
	
	return st;
}// Index_1

// ŒpbgϊibppF1,4,8j
Status Index_256_Fix(Bitmap *Bmp_R, Bitmap *Bmp_W, UINT kks, bool flag_Dither)
{
	Status		st = GenericError;
	BYTE		*pixels2 = NULL;	// ǂݍ݃f[^̃Rs[
	UINT		stride1;			// ǂݍ݃f[^4byteE
	BitmapData	bitmapData;
	UINT		wdh = Bmp_R->GetWidth();
	UINT		hgt = Bmp_R->GetHeight();
	Rect		rect(0, 0, wdh, hgt);
	UINT		nColors = 0;	// F
	BRGB		bRgb[256];		// pbgRGB
	UINT		i;
	
	PixelFormat	fmt	= Bmp_W->GetPixelFormat();
	UINT		bpp	= (BYTE)(fmt >> 8);	// F[x
	
	if(!(fmt & PixelFormatIndexed)){
		MessageBox (GetFocus(),"o̓tH[}bgpbgJ[ł͂܂","",MB_OK);
		return GenericError;
	}
	
	if(bpp <= 8){
		nColors = 1 << bpp;		// pbg̍őF
	}
	else{
		MessageBox (GetFocus(),"256Fȉ݂̂ɑΉĂ܂","",MB_OK);
		return st;
	}
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	ColorPalette *ppal = NULL;
	
	if(g_ppal){	// ǂݍ񂾃pbgꍇ
		st = Bmp_W->SetPalette(g_ppal);
		if(st != Ok){
			SAFE_DELETE_ARRAY_BYTE(g_ppal);
			MessageBox (GetFocus(),"pbgݒł܂","",MB_OK);
			SetCursor(hCurPre);
			return st;
		}
		// pbgl̓ǂݍ
		for(i=0; i<nColors; i++){
			bRgb[i].B = (BYTE) g_ppal->Entries[i];
			bRgb[i].G = (BYTE)(g_ppal->Entries[i] >> 8);
			bRgb[i].R = (BYTE)(g_ppal->Entries[i] >> 16);
		}
	}
	else{		// ftHgpbg̏ꍇ
		// ftHgpbg̎擾
		UINT p_sz = Bmp_W->GetPaletteSize();
		ppal = (ColorPalette *)new BYTE[p_sz];
		if (ppal != NULL){
			st = Bmp_W->GetPalette(ppal, p_sz);
			if(st != Ok){
				SAFE_DELETE_ARRAY_BYTE(ppal);
				MessageBox (GetFocus(),"pbg擾ł܂","",MB_OK);
				SetCursor(hCurPre);
				return st;
			}
		}
		else{	// ftHgpbgɎsApbg
			p_sz = sizeof(ColorPalette) + sizeof(ARGB)*(nColors-1);
			ppal = (ColorPalette *)new BYTE[p_sz];
			if (ppal == NULL){
				SetCursor(hCurPre);
				return OutOfMemory;
			}
			ZeroMemory(ppal, p_sz);
			Set_FixPal(ppal, nColors);
			st = Bmp_W->SetPalette(ppal);
			if(st != Ok){
				SAFE_DELETE_ARRAY_BYTE(ppal);
				MessageBox (GetFocus(),"pbgݒł܂","",MB_OK);
				SetCursor(hCurPre);
				return st;
			}
		}
		// pbgl̓ǂݍ
		for(i=0; i<nColors; i++){
			bRgb[i].B = (BYTE) ppal->Entries[i];
			bRgb[i].G = (BYTE)(ppal->Entries[i] >> 8);
			bRgb[i].R = (BYTE)(ppal->Entries[i] >> 16);
		}
	}
	
	// rbg̓ǂݍ
	st = Bmp_R->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels1 = NULL;	// 32bppFf
		
		if (bitmapData.Stride > 0)
			pixels1 = (BYTE*) bitmapData.Scan0;
		else
			pixels1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		pixels2 = new BYTE [stride1*hgt*sizeof(BYTE)];
		
		// pixels1pixels2ɃRs[
		memcpy(pixels2, pixels1, stride1*hgt*sizeof(BYTE));
		
		st = Bmp_R->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
			SAFE_DELETE_ARRAY(pixels2);
			SAFE_DELETE_ARRAY_BYTE(ppal);
			SetCursor(hCurPre);
			return st;
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
		SAFE_DELETE_ARRAY_BYTE(ppal);
		SetCursor(hCurPre);
		return st;
	}
	
	// rbgBmp_WɃZbg
	st = Bmp_W->LockBits(
			&rect,
			ImageLockModeWrite,
			fmt,
			&bitmapData);
	
	if (st == Ok)
	{
		BYTE *pixels = NULL;
		int 	pos,p_num;
		UINT	x,y;
		
		if (bitmapData.Stride > 0)
			pixels = (BYTE*) bitmapData.Scan0;
		else
			pixels = (BYTE*) bitmapData.Scan0 + bitmapData.Stride*(hgt-1);
		
		UINT stride = abs(bitmapData.Stride);
		
		// esNZ̋ߎFpbgTAFԍ
		for(y=0; y<hgt; y++){
			for(x=0; x<wdh; x++){
				pos = stride1*y+x*4;
				p_num = Select_Color(pixels2, pos, bRgb, nColors);
				Set_IdxClrPx(bpp, pixels, stride, x, y, p_num);
				// fBU
				if(flag_Dither)
					Dithering(x, y, wdh, hgt, stride1, pixels2, bRgb[p_num]);
			}
		}
		st = Bmp_W->UnlockBits(&bitmapData);
		if (st != Ok){
			MessageBox (GetFocus(),"BmpAbNł܂","",MB_OK);
		}
	}
	else{
		MessageBox (GetFocus(),"BmpbNł܂","",MB_OK);
	}
	SAFE_DELETE_ARRAY_BYTE(ppal);
	SAFE_DELETE_ARRAY(pixels2);
	SetCursor(hCurPre);
	
	return st;
}// Index_256_Fix

// Bmp_WɎ̌Œpbgݒ肷
void Set_FixPal(ColorPalette *ppal, int nColors)
{
	int				i;
	PALETTEENTRY	pe[256] = {0};
	COLORREF		rgb[16] = { 0xFFFFFFFF,0xFF000000,0xFFFF0000,0xFF00FF00,
								0xFF0000FF,0xFFFFFF00,0xFF00FFFF,0xFFFF00FF,
								0xFFBFBFBF,0xFF808080,0xFF800000,0xFF008000,
								0xFF000080,0xFF808000,0xFF008080,0xFF800080 };
	
	if(nColors == 256){
		Create_8bit_FixedPal(pe);
	}
	else{
		for(i=0; i<nColors; i++){
			pe[i] = RefToPe(rgb[i]);
		}
	}
	
	if(ppal){
		ppal->Flags = 0;
		ppal->Count = nColors;
		for (i = 0; i < nColors; i++)
		{
			ppal->Entries[i] = Color::MakeARGB( 0xff, 
											pe[i].peRed, 
											pe[i].peGreen, 
											pe[i].peBlue );
		}
	}
}// Set_FixPal

// 8bitŒpbg쐬
void Create_8bit_FixedPal(PALETTEENTRY *pe)
{
	COLORREF syscolor[20] = {0x000000, 0x000080, 0x008000, 0x008080, 0x800000,
							 0x800080, 0x808000, 0xC0C0C0, 0xC0DCC0, 0xF0CAA6,
							 0xF0FBFF, 0xA4A0A0, 0x808080, 0x0000FF, 0x00FF00,
							 0x00FFFF, 0xFF0000, 0xFF00FF, 0xFFFF00, 0xFFFFFF};
	BYTE clr[] = {0, 0x80, 0xff};
	BYTE r,g,b;
	int  j1,j2,j3,k1,k2,ct,n;
	bool flag = 0;
	
	ct = 0;
	for (j1=0; j1<10; j1++){
		pe[ct].peRed   = (BYTE) syscolor[j1];
		pe[ct].peGreen = (BYTE)(syscolor[j1] >>  8);
		pe[ct].peBlue  = (BYTE)(syscolor[j1] >> 16);
		ct ++;
	}
	for (j1=0; j1<3; j1++){
		for (j2=0; j2<3; j2++){
			for (j3=0; j3<3; j3++){
				r = clr[j1];
				g = clr[j2];
				b = clr[j3];
				for(k1=0; k1<20; k1++){
					if(syscolor[k1] == (COLORREF)(b << 16 | g << 8 | r)){
						flag = 1;
						break;
					}
				}
				if(flag){
					flag = 0;
					continue;
				}
				pe[ct].peRed   = r;
				pe[ct].peGreen = g;
				pe[ct].peBlue  = b;
				ct ++;
			}
		}
	}
	n = ct;
	for (j1=0; j1<6; j1++){
		for (j2=0; j2<6; j2++){
			for (j3=0; j3<6; j3++){
				r = (BYTE)(j1 * 51);
				g = (BYTE)(j2 * 51);
				b = (BYTE)(j3 * 51);
				for(k1=0; k1<20; k1++){
					if(syscolor[k1] == (COLORREF)(b << 16 | g << 8 | r)){
						flag = 1;
						break;
					}
				}
				for(k2=0; k2<n; k2++){
					if(r == pe[k2].peRed && g == pe[ct].peGreen && b == pe[ct].peBlue){
						flag = 1;
						break;
					}
				}
				if(flag){
					flag = 0;
					continue;
				}
				pe[ct].peRed   = r;
				pe[ct].peGreen = g;
				pe[ct].peBlue  = b;
				ct ++;
			}
		}
	}
	for (j1=0; j1<=17; j1++){
		r = (BYTE)(j1 * 15);
		g = (BYTE)(j1 * 15);
		b = (BYTE)(j1 * 15);
		for(k1=0; k1<20; k1++){
			if(syscolor[k1] == (COLORREF)(b << 16 | g << 8 | r)){
				flag = 1;
				break;
			}
		}
		if(flag){
			flag = 0;
			continue;
		}
		pe[ct].peRed   = r;
		pe[ct].peGreen = g;
		pe[ct].peBlue  = b;
		ct ++;
	}
	for (j1=10; j1<20; j1++){
		pe[ct].peRed   = (BYTE) syscolor[j1];
		pe[ct].peGreen = (BYTE)(syscolor[j1] >>  8);
		pe[ct].peBlue  = (BYTE)(syscolor[j1] >> 16);
		ct ++;
	}
}// Create_8bit_FixedPal

// O[XP[ϊ
Status Index_256_Gray(Bitmap *Bmp_R, Bitmap *Bmp_W, bool flag_Dither)
{
	Status		st = GenericError;
	UINT		nColors;		// F
	BYTE		*pixels2 = NULL;// ǂݍ݃f[^̃Rs[
	UINT		stride1;		// ǂݍ݃f[^4byteE
	BitmapData	bitmapData;
	UINT		wdh = Bmp_R->GetWidth();
	UINT		hgt = Bmp_R->GetHeight();
	Rect		rect(0, 0, wdh, hgt);
	
	PixelFormat	fmt	= Bmp_W->GetPixelFormat();
	UINT		bpp	= (BYTE)(fmt >> 8);	// F[x
	UINT		clr_max = 1 << bpp;
	
	if(!(fmt & PixelFormatIndexed)){
		MessageBox (GetFocus(),"o̓tH[}bgpbgJ[ł͂܂","",MB_OK);
		return GenericError;
	}
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	// Bmp_R32bittH[}bg̓ǂݍݐprbg}bv̈ƂăbN
	st = Bmp_R->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels1 = NULL;// 32bppFf
		BARGB	bARGB1[256+1];	// FiRGBIndexj
		
		if (bitmapData.Stride > 0)
			pixels1 = (BYTE*) bitmapData.Scan0;
		else
			pixels1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		pixels2 = new BYTE [stride1*hgt];
		
		// pixels1pixels2ɃRs[
		memcpy(pixels2, pixels1, stride1*hgt*sizeof(BYTE));
		
		// 摜256Fȉׂ
		nColors = Try_Get_Pixel(pixels1, bARGB1, wdh, hgt, stride1, clr_max);
		
		st = Bmp_R->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
			SAFE_DELETE_ARRAY(pixels2);
			SetCursor(hCurPre);
			return st;
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
		SetCursor(hCurPre);
		return st;
	}
	
	if (nColors > clr_max)
		nColors = clr_max;
	else if (nColors < 2)
		nColors = 2;
	
	BRGB	bRGB[256];
	DWORD	dwSizeColorPalette;
	dwSizeColorPalette = sizeof(ColorPalette);
	dwSizeColorPalette += sizeof(ARGB)*(nColors-1);
	
	ColorPalette *ppal = (ColorPalette *)new BYTE[dwSizeColorPalette];
	if (ppal == NULL){
		SAFE_DELETE_ARRAY(pixels2);
		SetCursor(hCurPre);
		return OutOfMemory;
	}
	
	ZeroMemory(ppal, dwSizeColorPalette);
	
	ppal->Flags = PaletteFlagsGrayScale;
	ppal->Count = nColors;
	for (UINT i = 0; i < nColors; i++)
	{
		int Intensity = i*0xFF/(nColors-1);
		
		ppal->Entries[i] = Color::MakeARGB( 255, 
											Intensity, 
											Intensity, 
											Intensity );
		bRGB[i].R = bRGB[i].G = bRGB[i].B = Intensity;
	}
	
	Bmp_W->SetPalette(ppal);
	
	st = Bmp_W->LockBits(
			&rect,
			ImageLockModeWrite,
			fmt,
			&bitmapData);
	
	if (st == Ok)
	{
		BYTE	*pixels = NULL;
		
		if (bitmapData.Stride > 0)
			pixels = (BYTE*) bitmapData.Scan0;
		else
			pixels = (BYTE*) bitmapData.Scan0 + bitmapData.Stride*(hgt-1);
		
		UINT stride = abs(bitmapData.Stride);
		
		for(UINT y = 0; y < hgt; ++y)
		{
			for(UINT x = 0; x < wdh; ++x)
			{
				Color 	pixel;
				UINT	i8BppPixel  = y * stride + x;
				UINT	i32BppPixel = y * stride1 + x * 4;
				
				double luminance =	(pixels2[i32BppPixel+2] * 0.299) +
									(pixels2[i32BppPixel+1] * 0.587) +
									(pixels2[i32BppPixel+0] * 0.114);
				
				UINT	val = (BYTE)(luminance * (nColors-1)/255 + 0.5);
				Set_IdxClrPx(bpp, pixels, stride, x, y, val);
				if(flag_Dither)
					Dithering(x, y, wdh, hgt, stride1, pixels2, bRGB[val]);
			}
		}
		st = Bmp_W->UnlockBits(&bitmapData);
		if (st != Ok){
			MessageBox (GetFocus(),"BmpAbNł܂","",MB_OK);
		}
	}
	else{
		MessageBox (GetFocus(),"BmpbNł܂","",MB_OK);
	}
	SAFE_DELETE_ARRAY_BYTE(ppal);
	SAFE_DELETE_ARRAY(pixels2);
	SetCursor(hCurPre);
	
	return st;
}// Index_256_Gray

// tJ[256FCfbNX쐬ij
Status Index_256(Bitmap *Bmp_R, Bitmap *Bmp_W, UINT kkx, UINT kky, UINT kks, bool flag_Dither, bool flag_Alpha)
{
	Status		st = GenericError;
	BitmapData	bitmapData;
	UINT		wdh = Bmp_R->GetWidth();
	UINT		hgt = Bmp_R->GetHeight();
	PixelFormat	fmt	= Bmp_W->GetPixelFormat();
	UINT		bpp	= (BYTE)(fmt >> 8);	// F[x
	UINT		index = 1 << bpp;		// F[xF߂
	Rect		rect(0, 0, wdh, hgt);
	BYTE	*pixels3 = NULL;		// *pixels1pal_256̑Ή\iŏIfj
	DWORD	pal_256[256];			// 256CfbNXiŏIpbgj
	int 	nColors;				// 256CfbNX̑iŏICfbNXj
	bool	flag_Alpha2 = false;	// 摜̓߃tO
	int		i;
	
	if(!(Bmp_W->GetPixelFormat() & PixelFormatIndexed)){
		MessageBox (GetFocus(),"o̓tH[}bgpbgJ[ł͂܂","",MB_OK);
		return GenericError;
	}
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	if(kkx < 1)			kkx = 1;
	else if(kkx > wdh)	kkx = wdh;
    if(kky < 1)			kky = 1;
	else if(kky > hgt)	kky = hgt;
	if(kks < 30)		kks = 30;
	else if(kks > 255)	kks = 255;
	
	// Bmp_R32bittH[}bg̓ǂݍݐprbg}bv̈ƂăbN
	st = Bmp_R->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels1 = NULL;		// 32bppFf
		BARGB	bARGB1[PICKUP_NUM+1];	// FiRGBIndex, 256Fȉ̏ꍇj
		int 	pos;
		UINT	x,y;
		DWORD	i_pxl[256+1]={0};		// ÕZ܂ł̗vf̘a
		DWORD	ct; 					// 32bppCfbNX̑
		UINT	stride1,stride2;		// ǂݍ݃f[^ƕۑf[^4byteE
		
		if (bitmapData.Stride > 0)
			pixels1 = (BYTE*) bitmapData.Scan0;
		else
			pixels1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		// ۑp4byteĚvZ
		stride2 = BytesPerLine(wdh, bpp);
		
		pixels3 = new BYTE [stride2 * hgt];
		
		// 摜 wFȉׂ
		ct = Try_Get_Pixel(pixels1, bARGB1, wdh, hgt, stride1, PICKUP_NUM);
		
		if(ct <= index){	// ct indexFȉꍇ
			flag_Alpha2 = false;
			nColors = (int) ct;
			for(i=0; i<nColors; i++){
				pal_256[i] = bARGB1[i].A << 24 | bARGB1[i].R << 16
						   | bARGB1[i].G << 8 | bARGB1[i].B;
				if(bARGB1[i].A == 0){
					flag_Alpha2 = true;
				}
			}
			qsort(pal_256, nColors, sizeof(DWORD),
				  (int (*)(const void*, const void*))DWORDcmp2);
			
			for(y=0; y<hgt; y++){
				for(x=0; x<wdh; x++){
					pos = stride1*y+x*4;
					DWORD argb = (pixels1[pos+3] << 24) | (pixels1[pos+2] << 16) | 
								 (pixels1[pos+1] << 8) | pixels1[pos+0];
					DWORD *result = (DWORD*) bsearch(&argb, pal_256, nColors, sizeof(DWORD),
													(int (*)(const void*, const void*))DWORDcmp2);
					Set_IdxClrPx(bpp, pixels3, stride2, x, y, result - pal_256);
				}
			}
		}
		else{			// ct (index+1)Fȏゾꍇ
			nColors = index;
			
			int		Rng[3];					// RGBeF͈̔(0:B 1:G 2:R)
			BRGB	bRGB2[256];
			int		Rng_idx = 0;	// ͈͂ő̐F(0:B 1:G 2:R)
			LPBRGB	bRGB1 = NULL;
			DWORD	*pixels2 = NULL;// ő32bpp̃CfbNX
			
			// 摜ŎgpĂF̎ނԈbRGB1ɓ
			if(ct > PICKUP_NUM){
				bRGB1 = (LPBRGB) new BYTE [(wdh / kkx + 1) * (hgt / kky + 1) * sizeof(BRGB)];
				ct = Get_Pixel(kkx, kky, pixels1, bRGB1, wdh, hgt, stride1, Rng);
			}
			else{
				bRGB1 = (LPBRGB) new BYTE [ct * sizeof(BRGB)];
				for(i=0; i<(int)ct; i++){
					bRGB1[i].R = bARGB1[i].R;
					bRGB1[i].G = bARGB1[i].G;
					bRGB1[i].B = bARGB1[i].B;
				}
			}
			
			// RGBeF͈̔͂őƂȂF(0:B 1:G 2:R)߂
			int Rng_Max = 0;
			for(i=0; i<3; i++){
				if(Rng[i] > Rng_Max){
					Rng_Max = Rng[i];
					Rng_idx = i;
				}
			}
			
			// F̃Tv256ɕ邽߂̑O
			Divide_Rest(ct, index, i_pxl);
			
			pixels2 = (LPDWORD) new BYTE [ct * sizeof(DWORD)];
			
			// F̃Tvёւix͔͈͂ő̐Fɂj
			for(i=0; i<(int)ct; i++){
				BYTE RGB_Rng_Max;
				switch(Rng_idx)
				{
				case 0:
					RGB_Rng_Max = bRGB1[i].B;
					break;
				case 1:
					RGB_Rng_Max = bRGB1[i].G;
					break;
				default:
					RGB_Rng_Max = bRGB1[i].R;
				}
				pixels2[i] = RGB_Rng_Max << 24 | bRGB1[i].R << 16
						   | bRGB1[i].G << 8 | bRGB1[i].B;
			}
			SAFE_DELETE_ARRAY_BYTE(bRGB1);
			
			// Rng_idx(0:B 1:G 2:R)FŃ\[g
			qsort(pixels2, ct, sizeof(DWORD),
				  (int (*)(const void*, const void*))DWORDcmp);
			
			// ԊuŐF𔲂oApbg̐FƂix0xffɂj
			for(i=0; i<(int)index; i++){
				pal_256[i] = 0xff000000 | pixels2[i_pxl[i]];
				// eFϐɓ꒼
				bRGB2[i].B = (BYTE)( pal_256[i]		& 0xff);
				bRGB2[i].G = (BYTE)((pal_256[i] >>  8) & 0xff);
				bRGB2[i].R = (BYTE)((pal_256[i] >> 16) & 0xff);
			}
			SAFE_DELETE_ARRAY_BYTE(pixels2);
			
			// esNZ̋ߎFpbgTAFԍ
			IRGB	sa;
			DWORD	sa_t,sa_min;
			int		p_num;
			BYTE	*pixels4 = NULL;	// fBUp
			
			pixels4 = new BYTE	[stride1 * hgt];
			memcpy(pixels4, pixels1, stride1*hgt*sizeof(BYTE));
			
			for(y=0; y<hgt; y++){
				for(x=0; x<wdh; x++){
					pos = stride1*y+x*4;
					int start = 0;
					int end = (int)index;
					if(kks < 100){
						for(i=0; i<(int)index; i++){
							int bdr = 0;
							switch(Rng_idx)
							{
							case 0:
								bdr = bRGB2[i].B - pixels4[pos+0];
								break;
							case 1:
								bdr = bRGB2[i].G - pixels4[pos+1];
								break;
							default:
								bdr = bRGB2[i].R - pixels4[pos+2];
							}
							if(bdr < 0){
								start = i - kks;
								if(start < 0){
									start = 0;
								}
								end = i + kks;
								if(end > (int)index){
									end = (int)index;
								}
								break;
							}
						}
					}
					p_num = 0;
					sa_min = 0xffffffff;
					for(i=start; i<end; i++){
						sa.B = bRGB2[i].B - pixels4[pos+0];
						if(sa.B < 0)	sa.B = -sa.B;
						sa.G = bRGB2[i].G - pixels4[pos+1];
						if(sa.G < 0)	sa.G = -sa.G;
						sa.R = bRGB2[i].R - pixels4[pos+2];
						if(sa.R < 0)	sa.R = -sa.R;
						
						sa_t = (sa.B + sa.G + sa.R) >> 1;
						sa_t += max3(sa.B, sa.G, sa.R);
						if(sa_t < sa_min){
							sa_min = sa_t;
							p_num = i;
						}
					}
					Set_IdxClrPx(bpp, pixels3, stride2, x, y, p_num);
					if(flag_Dither)
						Dithering(x, y, wdh, hgt, stride1, pixels4, bRGB2[p_num]);
				}
			}
			SAFE_DELETE_ARRAY(pixels4);
		}
		st = Bmp_R->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
			SAFE_DELETE_ARRAY(pixels3);
			SetCursor(hCurPre);
			return st;
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
		SetCursor(hCurPre);
		return st;
	}
	
	if(st == Ok){
		DWORD	dwSizeColorPalette;
		dwSizeColorPalette = sizeof(ColorPalette);
		dwSizeColorPalette += sizeof(ARGB)*(nColors-1);
		
		ColorPalette *ppal = (ColorPalette *)new BYTE[dwSizeColorPalette];
		if (ppal == NULL){
			MessageBox (GetFocus(), "sĂ܂", "", MB_OK);
			SAFE_DELETE_ARRAY(pixels3);
			SetCursor(hCurPre);
			return OutOfMemory;
		}
		
		ZeroMemory(ppal, dwSizeColorPalette);
		
		bool	flag_Alpha3;
		if(Bmp_R->GetPixelFormat() & PixelFormatAlpha){
			flag_Alpha3 = true;
		}
		else{
			flag_Alpha3 = false;
		}
		
		if(flag_Alpha & flag_Alpha2 & flag_Alpha3)
			ppal->Flags = PaletteFlagsHasAlpha;
		else
			ppal->Flags = 0;
		ppal->Count = nColors;
		for (i = 0; i < nColors; i++)
		{
			Color clr(pal_256[i]);
			ppal->Entries[i] = clr.GetValue();
		}
		
		st = Bmp_W->SetPalette(ppal);
		if (st != Ok)
		{
			MessageBox (GetFocus(),"pbg쐬ł܂","",MB_OK);
			SAFE_DELETE_ARRAY_BYTE(ppal);
			SAFE_DELETE_ARRAY(pixels3);
			SetCursor(hCurPre);
			return st;
		}
		
		st = Bmp_W->LockBits( &rect,
							ImageLockModeWrite,
							fmt,
							&bitmapData );
		if (st == Ok)
		{
			BYTE *pixels = NULL;
			if (bitmapData.Stride > 0)
				pixels = (BYTE*) bitmapData.Scan0;
			else
				pixels = (BYTE*) bitmapData.Scan0 + bitmapData.Stride*(hgt-1);
			
			UINT stride = abs(bitmapData.Stride);
			memcpy(pixels, pixels3, stride*hgt*sizeof(BYTE));
			
			st = Bmp_W->UnlockBits(&bitmapData);
		}
		if (st != Ok){
			MessageBox (GetFocus(),"Bmp_WbN̓bNł܂","",MB_OK);
		}
		SAFE_DELETE_ARRAY_BYTE(ppal);
	}
	SAFE_DELETE_ARRAY(pixels3);
	
	SetCursor(hCurPre);
	return st;
}// Index_256

// tJ[256FCfbNX쐬ifBA Jbgj
Status Index_256_Med(Bitmap *Bmp_R, Bitmap *Bmp_W, bool flag_Dither, bool flag_Alpha)
{
	Status		st = GenericError;
	BitmapData	bitmapData;
	UINT		wdh = Bmp_R->GetWidth();
	UINT		hgt = Bmp_R->GetHeight();
	PixelFormat	fmt	= Bmp_W->GetPixelFormat();
	UINT		bpp	= (BYTE)(fmt >> 8);	// F[x
	UINT		index = 1 << bpp;		// F[xF߂
	Rect		rect(0, 0, wdh, hgt);
	BYTE	*pixels2 = NULL;		// *pixels1pal_256̑Ή\iŏIfj
	DWORD	pal_256[256];			// 256CfbNXiŏIpbgj
	int 	nColors;				// 256CfbNX̑iŏICfbNXj
	bool	flag_Alpha2 = false;	// 摜̓߃tO
	int		i,j;
	
	if(!(Bmp_W->GetPixelFormat() & PixelFormatIndexed)){
		MessageBox (GetFocus(),"o̓tH[}bgpbgJ[ł͂܂","",MB_OK);
		return GenericError;
	}
	
	HCURSOR hCurPre = SetCursor(LoadCursor(NULL,IDC_WAIT));// vJ[\\
	
	// Bmp_R32bittH[}bg̓ǂݍݐprbg}bv̈ƂăbN
	st = Bmp_R->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels1 = NULL;		// 32bppFf
		int 	pos;
		UINT	x,y;
		UINT	stride1,stride2;		// ǂݍ݃f[^ƕۑf[^4byteE
		
		if (bitmapData.Stride > 0)
			pixels1 = (BYTE*) bitmapData.Scan0;
		else
			pixels1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		// ۑp4byteĚvZ
		stride2 = BytesPerLine(wdh, bpp);
		
		pixels2 = new BYTE [stride2 * hgt];
		
		BRGB	bRGB[256];				// pal_256 ̌ƂȂf[^
		BARGB	bARGB1[256+1];	// FiRGBIndex, 256Fȉ̏ꍇj
		
		// 摜 wFȉׂ
		UINT ct = Try_Get_Pixel(pixels1, bARGB1, wdh, hgt, stride1, index);
		
		if(ct <= index){	// ct  index Fȉꍇ
			flag_Alpha2 = false;
			nColors = (int) ct;
			for(i=0; i<nColors; i++){
				pal_256[i] = bARGB1[i].A << 24 | bARGB1[i].R << 16
						   | bARGB1[i].G << 8 | bARGB1[i].B;
				if(bARGB1[i].A == 0){
					flag_Alpha2 = true;
				}
			}
			qsort(pal_256, nColors, sizeof(DWORD),
				  (int (*)(const void*, const void*))DWORDcmp2);
			
			for(y=0; y<hgt; y++){
				for(x=0; x<wdh; x++){
					pos = stride1*y+x*4;
					DWORD argb = (pixels1[pos+3] << 24) | (pixels1[pos+2] << 16) | 
								 (pixels1[pos+1] << 8) | pixels1[pos+0];
					DWORD *result = (DWORD*) bsearch(&argb, pal_256, nColors, sizeof(DWORD),
													(int (*)(const void*, const void*))DWORDcmp2);
					Set_IdxClrPx(bpp, pixels2, stride2, x, y, result - pal_256);
				}
			}
		}
		else{			// ct (index+1)Fȏゾ
			ZeroMemory(g_mdn, sizeof(g_mdn));
			g_mdn[0].pData = (DATA*) malloc(wdh * hgt * sizeof(DATA));
			ZeroMemory(g_mdn[0].pData, wdh * hgt * sizeof(DATA));
			// 摜ŎgpĂF̎ނ𑍂g_mdn[0].pDataɓ
			g_mdn[0].data_len = Get_Pixel_All(pixels1, g_mdn[0].pData, wdh, hgt, stride1);
			// f[^񏉊
			Set_MdnInfo(0);
			// fBA Jbg
			UINT now = 0;	// ɕf[^ g_mdn ԍ
			UINT next = 1;	// f[^ g_mdn ԍ
			while(next < index){
				int		v_max = 0;
				for(i=0; i<(int)next; i++){
					int v_max2 = max3(g_mdn[i].len[0], g_mdn[i].len[1], g_mdn[i].len[2]);	// ő̐F͈͂߂
					if(v_max2 > v_max){
						v_max = v_max2;
						now = i;
					}
				}
				int 	n_max = max3n(g_mdn[now].len[0], g_mdn[now].len[1], g_mdn[now].len[2]);	// ͈͂ő̐Fԍ߂
				int		len_mid1 = g_mdn[now].data_len / 2;	// ̈̃f[^̍ŏ̗vfԍ
				int		len_mid2 = len_mid1 - 1;			// ̂̃f[^̍Ō̗vfԍ
				if(len_mid1 > 0){
					switch(n_max)
					{
					case 0:
						qsort(g_mdn[now].pData, g_mdn[now].data_len, sizeof(DATA),
						  (int (*)(const void*, const void*))DATAcmpB);
						break;
					case 1:
						qsort(g_mdn[now].pData, g_mdn[now].data_len, sizeof(DATA),
						  (int (*)(const void*, const void*))DATAcmpG);
						break;
					case 2:
						qsort(g_mdn[now].pData, g_mdn[now].data_len, sizeof(DATA),
						  (int (*)(const void*, const void*))DATAcmpR);
						break;
					}
					g_mdn[next].data_len = g_mdn[now].data_len - len_mid1;
					g_mdn[next].pData = (DATA*) malloc(g_mdn[next].data_len * sizeof(DATA));
					memcpy(g_mdn[next].pData, g_mdn[now].pData + len_mid1, g_mdn[next].data_len * sizeof(DATA));
					g_mdn[now].data_len = len_mid2 + 1;
					g_mdn[now].pData = (DATA*) realloc(g_mdn[now].pData, g_mdn[now].data_len * sizeof(DATA));
					Set_MdnInfo(now);
					Set_MdnInfo(next);
					next ++;
				}
				else{
					break;
				}
			}
			nColors = next;	// pbg̐F
			// pbgF쐬ix0xffɂBF͔z̐F̕ϒlƂj
			int sum_r,sum_g,sum_b,sum_num;
			for(i=0; i<(int)nColors; i++){
				for(j=0; j<3; j++){
					g_mdn[i].min[j] <<= 3;
					g_mdn[i].max[j] <<= 3;
				}
				sum_b = 0;
				sum_g = 0;
				sum_r = 0;
				sum_num = 0;
				for(j=0; j<g_mdn[i].data_len; j++){
					sum_b += (((g_mdn[i].pData[j].Val >> 10) & 0x1f) * g_mdn[i].pData[j].Num);
					sum_g += (((g_mdn[i].pData[j].Val >> 5)  & 0x1f) * g_mdn[i].pData[j].Num);
					sum_r += (( g_mdn[i].pData[j].Val        & 0x1f) * g_mdn[i].pData[j].Num);
					sum_num += g_mdn[i].pData[j].Num;
				}
				bRGB[i].B = (BYTE)((sum_b << 3) / sum_num);
				bRGB[i].G = (BYTE)((sum_g << 3) / sum_num);
				bRGB[i].R = (BYTE)((sum_r << 3) / sum_num);
				pal_256[i] = 0xff000000 | bRGB[i].R << 16 | bRGB[i].G << 8 | bRGB[i].B;
			}
			// 
			for(i=0; i<256; i++){
				FREE(g_mdn[i].pData);
			}
			// esNZ̋ߎFpbgTAFԍ
			int		p_num;
			BYTE	*pixels3 = NULL;	// fBUp
			BYTE	pxl[3];
			pixels3 = new BYTE	[stride1 * hgt];
			memcpy(pixels3, pixels1, stride1*hgt*sizeof(BYTE));
			for(y=0; y<hgt; y++){
				for(x=0; x<wdh; x++){
					pos = stride1*y+x*4;
					if(!flag_Dither){	// fBUł͂Ȃꍇ
						for(i=0; i<3; i++){
							pxl[i] = pixels3[pos+i] & 0xf8;
						}
						p_num = 0;
						for(i=0; i<(int)nColors; i++){
							if( pxl[0] >= g_mdn[i].min[0] && pxl[0] <= g_mdn[i].max[0] &&
								pxl[1] >= g_mdn[i].min[1] && pxl[1] <= g_mdn[i].max[1] &&
								pxl[2] >= g_mdn[i].min[2] && pxl[2] <= g_mdn[i].max[2])
							{
								p_num = i;
								break;
							}
						}
					}
					else{				// fBȔꍇ
						p_num = Select_Color(pixels3, pos, bRGB, nColors);
					}
					Set_IdxClrPx(bpp, pixels2, stride2, x, y, p_num);
					if(flag_Dither)		// fBȔꍇ
						Dithering(x, y, wdh, hgt, stride1, pixels3, bRGB[p_num]);
				}
			}
			SAFE_DELETE_ARRAY(pixels3);
		}
		
		st = Bmp_R->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
			SAFE_DELETE_ARRAY(pixels2);
			SetCursor(hCurPre);
			return st;
		}
	}
	else{
		MessageBox (GetFocus(),"Bmp_RbNł܂","",MB_OK);
		SetCursor(hCurPre);
		return st;
	}
	
	if(st == Ok){
		DWORD	dwSizeColorPalette;
		dwSizeColorPalette = sizeof(ColorPalette);
		dwSizeColorPalette += sizeof(ARGB)*(nColors-1);
		
		ColorPalette *ppal = (ColorPalette *)new BYTE[dwSizeColorPalette];
		if (ppal == NULL){
			MessageBox (GetFocus(), "sĂ܂", "", MB_OK);
			SAFE_DELETE_ARRAY(pixels2);
			SetCursor(hCurPre);
			return OutOfMemory;
		}
		
		ZeroMemory(ppal, dwSizeColorPalette);
		
		bool	flag_Alpha3;
		if(Bmp_R->GetPixelFormat() & PixelFormatAlpha){
			flag_Alpha3 = true;
		}
		else{
			flag_Alpha3 = false;
		}
		
		if(flag_Alpha & flag_Alpha2 & flag_Alpha3)
			ppal->Flags = PaletteFlagsHasAlpha;
		else
			ppal->Flags = 0;
		ppal->Count = nColors;
		for (i = 0; i < nColors; i++)
		{
			Color clr(pal_256[i]);
			ppal->Entries[i] = clr.GetValue();
		}
		
		st = Bmp_W->SetPalette(ppal);
		if (st != Ok)
		{
			MessageBox (GetFocus(),"pbg쐬ł܂","",MB_OK);
			SAFE_DELETE_ARRAY_BYTE(ppal);
			SAFE_DELETE_ARRAY(pixels2);
			SetCursor(hCurPre);
			return st;
		}
		
		st = Bmp_W->LockBits( &rect,
							ImageLockModeWrite,
							fmt,
							&bitmapData );
		if (st == Ok)
		{
			BYTE *pixels = NULL;
			if (bitmapData.Stride > 0)
				pixels = (BYTE*) bitmapData.Scan0;
			else
				pixels = (BYTE*) bitmapData.Scan0 + bitmapData.Stride*(hgt-1);
			
			UINT stride = abs(bitmapData.Stride);
			memcpy(pixels, pixels2, stride*hgt*sizeof(BYTE));
			
			st = Bmp_W->UnlockBits(&bitmapData);
		}
		if (st != Ok){
			MessageBox (GetFocus(),"Bmp_WbN̓bNł܂","",MB_OK);
		}
		SAFE_DELETE_ARRAY_BYTE(ppal);
	}
	SAFE_DELETE_ARRAY(pixels2);
	
	SetCursor(hCurPre);
	return st;
}// Index_256_Med

// zRGBꂼɂāAŏlAőlA߂
void Set_MdnInfo(int index)
{
	if(g_mdn[index].pData){
		int		i,r,g,b,min_r,min_g,min_b,max_r,max_g,max_b,len_r,len_g,len_b;
		min_r = 255;
		min_g = 255;
		min_b = 255;
		max_r = 0;
		max_g = 0;
		max_b = 0;
		for(i=0; i<g_mdn[index].data_len; i++){
			r = g_mdn[index].pData[i].Val & 0x1f;
			if(min_r > r)
				min_r = r;
			if(max_r < r)
				max_r = r;
			g = (g_mdn[index].pData[i].Val >> 5) & 0x1f;
			if(min_g > g)
				min_g = g;
			if(max_g < g)
				max_g = g;
			b = (g_mdn[index].pData[i].Val >> 10) & 0x1f;
			if(min_b > b)
				min_b = b;
			if(max_b < b)
				max_b = b;
		}
		len_r = max_r - min_r;
		len_g = max_g - min_g;
		len_b = max_b - min_b;
		
		g_mdn[index].min[0] = min_b;
		g_mdn[index].min[1] = min_g;
		g_mdn[index].min[2] = min_r;
		g_mdn[index].max[0] = max_b;
		g_mdn[index].max[1] = max_g;
		g_mdn[index].max[2] = max_r;
		g_mdn[index].len[0] = len_b;
		g_mdn[index].len[1] = len_g;
		g_mdn[index].len[2] = len_r;
	}
}// Set_MdnInfo

// sNZ̋ߎFpbgI
inline int Select_Color(BYTE *pixels, int pos, BRGB *bRGB, UINT nColors)
{
	int		i;
	IARGB	sa;
	UINT	sa_t,sa_min;
	int		p_num = 0;
	sa_min = 0xffffffff;
	for(i=0; i<(int)nColors; i++){
		sa.B = bRGB[i].B - pixels[pos+0];
		if(sa.B < 0)	sa.B = -sa.B;
		sa.G = bRGB[i].G - pixels[pos+1];
		if(sa.G < 0)	sa.G = -sa.G;
		sa.R = bRGB[i].R - pixels[pos+2];
		if(sa.R < 0)	sa.R = -sa.R;
		sa_t = (sa.B + sa.G + sa.R) >> 1;
		sa_t += max3(sa.B, sa.G, sa.R);
		if( sa_t < sa_min){
			sa_min = sa_t;
			p_num = i;
		}
	}
	return p_num;
}// Select_Color

// NCbN\[g̔r֐i~j
int DWORDcmp(const DWORD *a, const DWORD *b)
{
	// rbgmۂ邽߁AE1bitVtg
	return ((*b >> 1) - (*a >> 1));
}

// NCbN\[g̔r֐i~j
int DWORDcmp2(const DWORD *a, const DWORD *b)
{
	return ((*b) - (*a));
}

// NCbN\[g̔r֐iEԁj
int DATAcmpR(const DATA *a, const DATA *b)
{
	return ((a->Val & 0x1f) - (b->Val & 0x1f));
}

// NCbN\[g̔r֐iE΁j
int DATAcmpG(const DATA *a, const DATA *b)
{
	return (((a->Val >> 5) & 0x1f) - ((b->Val >> 5) & 0x1f));
}

// NCbN\[g̔r֐iEj
int DATAcmpB(const DATA *a, const DATA *b)
{
	return (((a->Val >> 10) & 0x1f) - ((b->Val >> 10) & 0x1f));
}

// 摜 numClrsFȉׂ
// bRng F RGBeF͈̔
WORD Try_Get_Pixel(BYTE *pixels1, BARGB *bARGB1, UINT wdh, UINT hgt, UINT stride1, UINT numClrs)
{
	UINT	x,y,flag,pos;
	WORD	k,ct;
	
	ct = 0;
	for(y=0; y<hgt; y++){
		for(x=0; x<wdh; x++){
			pos = stride1*y+x*4;
			flag = 0;
			for(k=0; k<ct; k++){
				if( (bARGB1[k].B == pixels1[pos+0]) && 
					(bARGB1[k].G == pixels1[pos+1]) && 
					(bARGB1[k].R == pixels1[pos+2]) && 
					(bARGB1[k].A == pixels1[pos+3]))
				{
					flag = 1;
					break;
				}
			}
			if(flag == 0){
				Try_Get_Pixel_Sub(ct,pos,pixels1,bARGB1);
				ct ++;
				
				if(ct > numClrs){
					return ct;
				}
			}
		}
	}
	return ct;
}// Try_Get_Pixel

void Try_Get_Pixel_Sub(DWORD ct, UINT pos, BYTE *pixels1, BARGB *bARGB1)
{
	bARGB1[ct].B = pixels1[pos+0];
	bARGB1[ct].G = pixels1[pos+1];
	bARGB1[ct].R = pixels1[pos+2];
	bARGB1[ct].A = pixels1[pos+3];
}// Try_Get_Pixel_Sub

// 摜ŎgpSĂ̐FAԈĎo
// kkx,kky : ԈW
// pixel1  : 摜̃sNZlA
// bRGB1   : oFf[^i[\́A
// stride1 : 4byteẺ
// bRng    : RGBeF͈̔
DWORD Get_Pixel(UINT kkx, UINT kky, BYTE *pixels1, BRGB *bRGB1, UINT wdh, UINT hgt, UINT stride1, int *bRng)
{
	UINT	i,x,y,flag,pos;
	DWORD	k,ct;
	BRGB	bMin,bMax;
	BYTE	pxl[3];
	
	bMin.R = bMin.G = bMin.B = 255;
	bMax.R = bMax.G = bMax.B = 0;
	ct = 0;
	for(y=0; y<hgt; y+= kky){
		for(x=0; x<wdh; x+= kkx){
			pos = stride1*y+x*4;
			for(i=0;i<3;i++){
				pxl[i] = pixels1[pos+i] & 0xfc;	// 2bit0ɂ
			}
			flag = 0;
			for(k=0; k<ct; k++){
				if( bRGB1[k].B == pxl[0] &&  
					bRGB1[k].G == pxl[1] &&
					bRGB1[k].R == pxl[2])
				{
					flag = 1;
					break;
				}
			}
			if(flag == 0){
				Get_Pixel_Sub(ct,pxl,bRGB1,&bMin,&bMax);
				ct ++;
			}
		}
	}
	bRng[0] = (int)(bMax.B - bMin.B);
	bRng[1] = (int)(bMax.G - bMin.G);
	bRng[2] = (int)(bMax.R - bMin.R);
	return ct;
}// Get_Pixel

void Get_Pixel_Sub(DWORD ct, BYTE *pxl, BRGB *bRGB1, BRGB *bMin, BRGB *bMax)
{
	bRGB1[ct].B = pxl[0];
	bRGB1[ct].G = pxl[1];
	bRGB1[ct].R = pxl[2];
	
	Get_Pixel_Sub2(&bRGB1[ct],bMin,bMax);
}// Get_Pixel_Sub

void Get_Pixel_Sub2(BRGB *bRGB1, BRGB *bMin, BRGB *bMax)
{
	// RGBꂼ̐F͈͂߂
	if(bMin != NULL){
		if(bRGB1->R < bMin->R)
			bMin->R = bRGB1->R;
		if(bRGB1->G < bMin->G)
			bMin->G = bRGB1->G;
		if(bRGB1->B < bMin->B)
			bMin->B = bRGB1->B;
	}
	if(bMax != NULL){
		if(bRGB1->R > bMax->R)
			bMax->R = bRGB1->R;
		if(bRGB1->G > bMax->G)
			bMax->G = bRGB1->G;
		if(bRGB1->B > bMax->B)
			bMax->B = bRGB1->B;
	}
}// Get_Pixel_Sub2

// 摜ŎgpSĂ̐Fo
// pixel1  : 摜̃sNZl
// pData    : oFf[^i[\
// stride1 : 4byteẺ
// ߂l  : f
DWORD Get_Pixel_All(BYTE *pixels1, DATA *pData, UINT wdh, UINT hgt, UINT stride1)
{
	if(!pixels1 || !pData){
		return 0;
	}
	
	UINT	i,x,y,flag,pos;
	DWORD	k,ct;
	BYTE	pxl[3];
	
	int		n_max = (1 << (sizeof(WORD) * 8)) - 1;
	
	ct = 0;
	for(y=0; y<hgt; y++){
		for(x=0; x<wdh; x++){
			pos = stride1*y+x*4;
			for(i=0;i<3;i++){
				pxl[i] = pixels1[pos+i] >> 3;
			}
			flag = 0;
			for(k=0; k<ct; k++){
				if(((pData[k].Val >> 10) & 0x1f) == pxl[0] &&
				   ((pData[k].Val >>  5) & 0x1f) == pxl[1] &&
				   ( pData[k].Val        & 0x1f) == pxl[2])
				{
					flag = 1;
					if(pData[k].Num < n_max){
						pData[k].Num ++;
					}
					break;
				}
			}
			if(flag == 0){
				pData[ct].Val = (pxl[0] << 10) | (pxl[1] << 5) | pxl[2];
				pData[ct].Num ++;
				ct ++;
			}
		}
	}
	return ct;
}// Get_Pixel_All

// fBUO
void Dithering(UINT x, UINT y, UINT wdh, UINT hgt, UINT stride1, BYTE *pixels, BRGB bRgb)
{
	int		pos1,pos2;
	IRGB	gk;
	
	pos1 = stride1*y+x*4;

	gk.B = pixels[pos1+0] - bRgb.B;
	gk.G = pixels[pos1+1] - bRgb.G;
	gk.R = pixels[pos1+2] - bRgb.R;

	if(x < wdh-1){
		pos2 = stride1*y+(x+1)*4;
		Dithering_Sub(7,pos2,pixels,gk);
	}
	if(y < hgt-1){
		pos2 = stride1*(y+1)+x*4;
		Dithering_Sub(5,pos2,pixels,gk);
	}
	if((x < wdh-1) && (y < hgt-1)){
		pos2 = stride1*(y+1)+(x+1)*4;
		Dithering_Sub(1,pos2,pixels,gk);
	}
	if(x > 0 && (y < hgt-1)){
		pos2 = stride1*(y+1)+(x-1)*4;
		Dithering_Sub(3,pos2,pixels,gk);
	}
}// Dithering

void Dithering_Sub(int gv, int pos2, BYTE *pixels, IRGB gk)
{
	int ad_r,ad_g,ad_b;

	ad_b = pixels[pos2+0] + (gk.B*gv/16);
	ad_g = pixels[pos2+1] + (gk.G*gv/16);
	ad_r = pixels[pos2+2] + (gk.R*gv/16);
	if(ad_b < 0)	ad_b = 0;
	if(ad_b > 255)	ad_b = 255;
	if(ad_g < 0)	ad_g = 0;
	if(ad_g > 255)	ad_g = 255;
	if(ad_r < 0)	ad_r = 0;
	if(ad_r > 255)	ad_r = 255;
	pixels[pos2+0] = ad_b;
	pixels[pos2+1] = ad_g;
	pixels[pos2+2] = ad_r;
}// Dithering_Sub

// 1,4,8bit̃J[fvXʂɃsNZlݒ肷
void Set_IdxClrPx(int bpp, BYTE *pixels, UINT stride, int x, int y, int val)
{
	if(bpp == 1){
		if(x % 8 == 1)
			pixels[stride*y+x/8] |= ((val & 1) << 6);
		else if(x % 8 == 2)
			pixels[stride*y+x/8] |= ((val & 1) << 5);
		else if(x % 8 == 3)
			pixels[stride*y+x/8] |= ((val & 1) << 4);
		else if(x % 8 == 4)
			pixels[stride*y+x/8] |= ((val & 1) << 3);
		else if(x % 8 == 5)
			pixels[stride*y+x/8] |= ((val & 1) << 2);
		else if(x % 8 == 6)
			pixels[stride*y+x/8] |= ((val & 1) << 1);
		else if(x % 8 == 7)
			pixels[stride*y+x/8] |= val & 1;
		else
			pixels[stride*y+x/8] = val << 7;
	}
	else if(bpp == 4){
		if(x % 2)
			pixels[stride*y+x/2] |= val & 0xf;
		else
			pixels[stride*y+x/2] =  val << 4;
	}
	else{
		pixels[stride*y+x] = (BYTE) val;
	}
}// Set_IdxClrPx
