Status Draw_Grid(Bitmap *Bmp, Rect rcBmp_E, int zoom, POINT interval, POINT offset);

// Obh̕`
// interval	F Obh̊Ԋu
Status Draw_Grid(Bitmap *Bmp, Rect rcBmp_E, int zoom, POINT interval, POINT offset)
{
	Status st = GenericError;;
	
	if(!Bmp || zoom == 0 || (interval.x == 0 && interval.y == 0)){
		return st;
	}
	
	if(interval.x == 0){
		interval.x = Bmp->GetWidth();
	}
	
	if(interval.y == 0){
		interval.y = Bmp->GetHeight();
	}
	
	BitmapData	bitmapData;
	UINT		x0  = rcBmp_E.X;
	UINT		y0  = rcBmp_E.Y;
	UINT		wdh = x0 + rcBmp_E.Width;
	UINT		hgt = y0 + rcBmp_E.Height;
	POINT		offset2;
	Rect		rect(0, 0, wdh, hgt);
	st = Bmp->LockBits(&rect, ImageLockModeRead | ImageLockModeWrite, 
								PixelFormat24bppRGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels = NULL,clr;
		int 	pos1;
		UINT	x,y,clr_add;
		
		if (bitmapData.Stride > 0)
			pixels = (BYTE*) bitmapData.Scan0;
		else
			pixels = (BYTE*) bitmapData.Scan0 + bitmapData.Stride*(hgt-1);
		
		UINT stride = abs(bitmapData.Stride);
		
		int zoom2 = zoom / 100;
		if(zoom2 == 0){
			zoom2 = 1;
		}
		
		offset2.x = (offset.x * zoom2) % (interval.x * zoom2);
		offset2.y = (offset.y * zoom2) % (interval.y * zoom2);
		
		for(y=y0; y<hgt; y++){
			for(x=x0; x<wdh; x++){
				pos1 = y*stride+x*3;
				if( ((x - x0 + scr_x + offset2.x) % (interval.x * zoom2) == 0) || 
					((y - y0 + scr_y + offset2.y) % (interval.y * zoom2) == 0))
				{
					clr_add = pixels[pos1+0] + pixels[pos1+1] + pixels[pos1+2];
					if(clr_add >= 0x180){
						clr = 0;
					}
					else{
						clr = 255;
					}
					pixels[pos1+0] = pixels[pos1+1] = pixels[pos1+2] = clr;
				}
			}
		}
		st = Bmp->UnlockBits(&bitmapData);
		if (st != Ok){
			MessageBox (GetFocus(),"BmpAbNł܂","",MB_OK);
		}
	}
	else{
		MessageBox (GetFocus(),"BmpbNł܂","",MB_OK);
	}
	return st;
}// Draw_Grid
