Status	Get_PropertyStr(char *strProp, int len, Bitmap *Bmp, PROPID propId);
Status	Set_EditPropertyDlg(Bitmap *Bmp, HWND hDlg, UINT idEdit, PROPID propId);
Status	Set_ImagePropertyText(Bitmap *Bmp, PROPID propId, char *str, int len);

// 摜̃vpeB擾
// strProp	: [OUT]	󂯎vpeBi[obt@
// len		: [IN]	strProp ̃obt@TCY
// Bmp		: [IN]	vpeBo BMP IuWFNg
// propId	: [IN]	ovpeBڂID
Status Get_PropertyStr(char *strProp, int len, Bitmap *Bmp, PROPID propId)
{
	Status st = GenericError;
	
	if(!strProp){
		return st;
	}
	
	UINT propSize = Bmp->GetPropertyItemSize(propId);
	if(propSize > 0){
		PropertyItem *pPropBuffer = (PropertyItem*) malloc(propSize);
		st = Bmp->GetPropertyItem(propId, propSize, pPropBuffer);
		if(st == Ok){
			if(pPropBuffer->type == PropertyTagTypeASCII){
				strncpy(strProp, (char*) pPropBuffer->value, len - 1);
			}
			else{
				_snprintf(strProp, len - 1, "%u", pPropBuffer->value);
			}
		}
		free(pPropBuffer);
	}
	return st;
}// Get_PropertyStr

// _CAÕGfBbgɉ摜̃vpeBݒ肷
Status Set_EditPropertyDlg(Bitmap *Bmp, HWND hDlg, UINT idEdit, PROPID propId)
{
	Status st = GenericError;
	
	UINT propSize = Bmp->GetPropertyItemSize(propId);
	if(propSize > 0){
		PropertyItem *pPropBuffer = (PropertyItem*) malloc(propSize);
		st = Bmp->GetPropertyItem(propId, propSize, pPropBuffer);
		if(st == Ok){
			char str[256];
			if(pPropBuffer->type == PropertyTagTypeASCII){
				strncpy(str, (char*) pPropBuffer->value, sizeof(str)-1);
			}
			else{
				_snprintf(str, sizeof(str)-1, "%u", pPropBuffer->value);
			}
			SendDlgItemMessage(hDlg, idEdit, WM_SETTEXT, 0, (LPARAM) str);
		}
		free(pPropBuffer);
	}
	return st;
}// Set_EditPropertyDlg

// 摜ɃvpeBݒ肷
Status	Set_PropertyText(Bitmap *Bmp, PROPID propId, char *str, int len)
{
	PropertyItem* propertyItem = new PropertyItem;
	propertyItem->id = propId;
	propertyItem->length = len;	// ̒iNULL܂ށj
	propertyItem->type = PropertyTagTypeASCII; 
	propertyItem->value = str;
	Status st = Bmp->SetPropertyItem(propertyItem);
	delete propertyItem;
	return st;
}// Set_PropertyText
