 void Rectangle_MouseMove(Rect *rc1, Rect *rc2, Rect clip, Point *pt_bgn, Point pos, WPARAM wParam, int zoom);
void Ellipse_MouseMove  (Rect *rc1, Rect *rc2, Rect clip, Point *pt_bgn, Point pos, WPARAM wParam, int zoom);

// `Ii}EXƂj
void Rectangle_MouseMove(Rect *rc1, Rect *rc2, Rect clip, Point *pt_bgn, Point pos, WPARAM wParam, int zoom)
{
	if(pt_bgn->X == -1 && pt_bgn->Y == -1)
		return;
	
	if((short)pos.X < clip.X)
		pos.X = clip.X;
	if((short)pos.X >= clip.X + clip.Width)
		pos.X = clip.X + clip.Width -1;
	if((short)pos.Y < clip.Y)
		pos.Y = clip.Y;
	if((short)pos.Y >= clip.Y + clip.Height)
		pos.Y = clip.Y + clip.Height - 1;
	
	if((short)pt_bgn->X < 0)
		pt_bgn->X = pos.X;
	if((short)pt_bgn->Y < 0)
		pt_bgn->Y = pos.Y;
	
	RECT rc;
	
	if((short)pos.X >= (short)pt_bgn->X){
		rc.left  = scr_x + pt_bgn->X;
		rc.right = scr_x + pos.X;
	}
	else{
		rc.left  = scr_x + pos.X;
		rc.right = scr_x + pt_bgn->X;
	}
	
	if((short)pos.Y >= (short)pt_bgn->Y){
		rc.top    = scr_y + pt_bgn->Y;
		rc.bottom = scr_y + pos.Y;
	}
	else{
		rc.top    = scr_y + pos.Y;
		rc.bottom = scr_y + pt_bgn->Y;
	}
	
	rc.left   -= clip.X;
	rc.top    -= clip.Y;
	rc.right  -= clip.X;
	rc.bottom -= clip.Y;
	
	if(wParam & MK_SHIFT){	// VtgL[ĂƂ
		if(rc.right - rc.left >= rc.bottom - rc.top){
			if((short)pos.X >= (short)pt_bgn->X)
				rc.right  = rc.left + (rc.bottom - rc.top);
			else
				rc.left  = rc.right + (rc.top - rc.bottom);
		}
		else{
			if((short)pos.Y >= (short)pt_bgn->Y)
				rc.bottom = rc.top + (rc.right - rc.left);
			else
				rc.top = rc.bottom + (rc.left - rc.right);
		}
	}
	
	// \{-100%
	rc1->X      = rc.left * 100 / zoom;
	rc1->Y      = rc.top * 100 / zoom;
	rc1->Width  = rc.right * 100 / zoom;
	rc1->Height = rc.bottom * 100 / zoom;
	
	// \{-
	rc2->X      = rc1->X * zoom / 100 + clip.X;
	rc2->Y      = rc1->Y * zoom / 100 + clip.Y;
	rc2->Width  = rc1->Width * zoom / 100 + clip.X;
	rc2->Height = rc1->Height * zoom / 100 + clip.Y;
	
}// Rectangle_MouseMove

// ~`Wi}EXƂj
void Ellipse_MouseMove(Rect *rc1, Rect *rc2, Rect clip, Point *pt_bgn, Point pos, WPARAM wParam, int zoom)
{
	if(pt_bgn->X == -1 && pt_bgn->Y == -1)
		return;
	
	if((short)pos.X < clip.X)
		pos.X = clip.X;
	if((short)pos.X >= clip.X + clip.Width)
		pos.X = clip.X + clip.Width - 1;
	if((short)pos.Y < clip.Y)
		pos.Y = clip.Y;
	if((short)pos.Y >= clip.Y + clip.Height)
		pos.Y = clip.Y + clip.Height - 1;
	
	if((short)pt_bgn->X < 0)
		pt_bgn->X = pos.X;
	if((short)pt_bgn->Y < 0)
		pt_bgn->Y = pos.Y;
	
	RECT rc;
	
	rc.left   = scr_x + pt_bgn->X - clip.X;
	rc.right  = pos.X - pt_bgn->X;
	rc.top    = scr_y + pt_bgn->Y - clip.Y;
	rc.bottom = pos.Y - pt_bgn->Y;
	
	if(wParam & MK_SHIFT){
		if(rc.right > rc.bottom){
			if((pos.X >= pt_bgn->X && pos.Y >= pt_bgn->Y) ||
			   (pos.X <= pt_bgn->X && pos.Y <= pt_bgn->Y))
				rc.right = rc.bottom;
			else
				rc.right = - rc.bottom;
		}
		else{
			if((pos.X >= pt_bgn->X && pos.Y >= pt_bgn->Y) || 
			   (pos.X <= pt_bgn->X && pos.Y <= pt_bgn->Y))
				rc.bottom = rc.right;
			else
				rc.bottom = - rc.right;
		}
		if(rc.left - scr_x + rc.right < 0){
			rc.right = - (rc.left - scr_x);
			if(rc.bottom < 0)
				rc.bottom = rc.right;
			else
				rc.bottom = - rc.right;
		}
		else if(rc.left - scr_x + rc.right > clip.Width){
			rc.right = clip.Width - (rc.left - scr_x);
			if(rc.bottom < 0)
				rc.bottom = - rc.right;
			else
				rc.bottom = rc.right;
		}
		if(rc.top - scr_y + rc.bottom < 0){
			rc.bottom = - (rc.top - scr_y);
			if(rc.right < 0)
				rc.right = rc.bottom;
			else
				rc.right = - rc.bottom;
		}
		else if(rc.top - scr_y + rc.bottom > clip.Height){
			rc.bottom = clip.Height - (rc.top - scr_y);
			if(rc.right < 0)
				rc.right = - rc.bottom;
			else
				rc.right = rc.bottom;
		}
	}
	
	// \{-100%
	rc1->X      = rc.left * 100 / zoom;
	rc1->Y      = rc.top * 100 / zoom;
	rc1->Width  = rc.right * 100 / zoom;
	rc1->Height = rc.bottom * 100 / zoom;
	
	// \{-
	rc2->X      = rc1->X * zoom / 100 + clip.X;
	rc2->Y      = rc1->Y * zoom / 100 + clip.Y;
	rc2->Width  = rc1->Width * zoom / 100;
	rc2->Height = rc1->Height * zoom / 100;
	
}// Ellipse_MouseMove
