Point Get_Point_Spe(Point pt, int x, int y, int wdhSpe, int hgtSpe, int wdh, int hgt);
Status Draw_Special(Bitmap *Bmp, Bitmap *BmpSpe, BYTE *flag, int index, int val, BYTE alpha, bool flag_mask);

Point Get_Point_Spe(Point pt, int x, int y, int wdhSpe, int hgtSpe, int wdh, int hgt)
{
	Point ptDst;
	ptDst.X = pt.X - wdhSpe / 2 + x;
	ptDst.Y = pt.Y - hgtSpe / 2 + y;
	Set_Pt_Limit(&ptDst, 0, 0, wdh-1, hgt-1);
	
	return ptDst;
}// Get_Point_Spe

// c[ɂ`
Status Draw_Special(Bitmap *Bmp, Bitmap *BmpSpe, BYTE *flag, int index, int val, BYTE alpha, bool flag_mask)
{
	Status		st = GenericError;
	
	if(!Bmp || !BmpSpe || (flag_mask && !flag) || !g_Spe.pos){
		return st;
	}
	
	UINT		wdh = Bmp->GetWidth();
	UINT		hgt = Bmp->GetHeight();
	PixelFormat	fmt	= Bmp->GetPixelFormat();
	UINT		bpp	= (BYTE)(fmt >> 8);	// F[x
	int			wdhSpe = BmpSpe->GetWidth();
	int			hgtSpe = BmpSpe->GetHeight();
	int			i,x,y;
	float		prm;
	
	if(fmt & PixelFormatIndexed){
		MessageBox (GetFocus(),"CfbNXJ[ɂ͑ΉĂ܂","",MB_OK);
		return GenericError;
	}
	
	const int val2[] = {1,2,3,5,10,15,20,25,100};
	
	switch(index)
	{
	case 0:	// ɂ
	case 1:	// ɂ݁ix̂݁j
		prm = (float)(val + 1) / 10.0f;
		break;
	case 3:	// xij
	case 4:	// xij
		if(!flag_mask)
			prm = (float)(val + 1) / (50.0f + wdhSpe) * 255.0f;
		else
			prm = (float)(val + 1) * 25.5f;
		break;
	case 5:	// ʓxij
		if(!flag_mask)
			prm = (float) val2[val];
		else
			prm = (float)(val + 1) * 25.5f;
		break;
	case 6:	// ʓxij
		if(!flag_mask)
			prm = - (float) val2[val];
		else
			prm = - (float)(val + 1) * 25.5f;
		break;
	}
	
	if(bpp != 24 && bpp != 32){
		for(y=0;y<hgtSpe;y++){
			for(x=0;x<wdhSpe;x++){
				Color	clr_dot;
				BmpSpe->GetPixel(x, y, &clr_dot);
				if(clr_dot.GetA()){	// A,R,G,B ̂ǂꂩ10ł͂Ȃ
					for(i=0;i<g_Spe.pos_num-1;i++){
						Color	clr_pre,clr_nxt;
						Point	pt_pre,pt_nxt;
						pt_pre = Get_Point_Spe(g_Spe.pos[i], x, y, wdhSpe, hgtSpe, wdh, hgt);
						pt_nxt = Get_Point_Spe(g_Spe.pos[i+1], x, y, wdhSpe, hgtSpe, wdh, hgt);
						Bmp->GetPixel(pt_nxt.X, pt_nxt.Y, &clr_nxt);
						int ab_flag =  pt_nxt.Y * wdh + pt_nxt.X;
						if(!flag_mask || (flag_mask && flag && flag[ab_flag] != 1)){
							switch(index)
							{
							case 0:	// ɂ
								{
									BYTE	a,r,g,b;
									st = Bmp->GetPixel(pt_pre.X, pt_pre.Y, &clr_pre);
									a = (BYTE)(prm * clr_pre.GetA() + (1.0f - prm) * clr_nxt.GetA());
									r = (BYTE)(prm * clr_pre.GetR() + (1.0f - prm) * clr_nxt.GetR());
									g = (BYTE)(prm * clr_pre.GetG() + (1.0f - prm) * clr_nxt.GetG());
									b = (BYTE)(prm * clr_pre.GetB() + (1.0f - prm) * clr_nxt.GetB());
									Color	clr_dst(a, r, g, b);
									st = Bmp->SetPixel(pt_nxt.X, pt_nxt.Y, clr_dst);
								}
								break;
							case 1:	// ɂ݁ix̂݁j
								{
									BYTE	a,r,g,b;
									st = Bmp->GetPixel(pt_pre.X, pt_pre.Y, &clr_pre);
									a = (BYTE)(prm * clr_pre.GetA() + (1.0f - prm) * clr_nxt.GetA());
									r = clr_nxt.GetR();
									g = clr_nxt.GetG();
									b = clr_nxt.GetB();
									Color	clr_dst(a, r, g, b);
									st = Bmp->SetPixel(pt_nxt.X, pt_nxt.Y, clr_dst);
								}
								break;
							case 2:	// x
								{
									BYTE a = 255 - alpha;
									ARGB argb = (clr_nxt.GetValue() & 0xffffff) | (a << ALPHA_SHIFT);
									st = Bmp->SetPixel(pt_nxt.X, pt_nxt.Y, Color(argb));
								}
								break;
							case 3:	// xij
								{
									int	a,r,g,b,r_dst,g_dst,b_dst;
									int	prm2 = (int) prm;
									a = clr_nxt.GetA();
									r = clr_nxt.GetR();
									g = clr_nxt.GetG();
									b = clr_nxt.GetB();
									r_dst = (int)(r + prm2);
									g_dst = (int)(g + prm2);
									b_dst = (int)(b + prm2);
									if(r_dst > 255)	r_dst = 255;
									if(g_dst > 255)	g_dst = 255;
									if(b_dst > 255)	b_dst = 255;
									Color	clr_dst(a, r_dst, g_dst, b_dst);
									st = Bmp->SetPixel(pt_nxt.X, pt_nxt.Y, clr_dst);
								}
								break;
							case 4:	// xij
								{
									int	a,r,g,b,r_dst,g_dst,b_dst;
									int	prm2 = (int) prm;
									a = clr_nxt.GetA();
									r = clr_nxt.GetR();
									g = clr_nxt.GetG();
									b = clr_nxt.GetB();
									r_dst = (int)(r - prm2);
									g_dst = (int)(g - prm2);
									b_dst = (int)(b - prm2);
									if(r_dst < 0)	r_dst = 0;
									if(g_dst < 0)	g_dst = 0;
									if(b_dst < 0)	b_dst = 0;
									Color	clr_dst(a, r_dst, g_dst, b_dst);
									st = Bmp->SetPixel(pt_nxt.X, pt_nxt.Y, clr_dst);
								}
								break;
							case 5:	// ʓxij
							case 6:	// ʓxij
								{
									float	val,sub,lum;
									int		i;
									BYTE	clr[4];
									clr[0] = clr_nxt.GetA();
									clr[1] = clr_nxt.GetR();
									clr[2] = clr_nxt.GetG();
									clr[3] = clr_nxt.GetB();
									lum =	(clr[3] * 0.114f) +
											(clr[2] * 0.587f) +
											(clr[1] * 0.299f) + 0.5f;
									for(i=1;i<4;i++){
										sub = (float) clr[i] - lum;
										val = (float) clr[i] + (sub / 255) * ((int)(255 + prm) - 255);
										if(val > 255){
											val = 255;
										}
										else if(val < 0){
											val = 0;
										}
										clr[i] = (BYTE) val;
									}
									Color	clr_dst(clr[0], clr[1], clr[2], clr[3]);
									st = Bmp->SetPixel(pt_nxt.X, pt_nxt.Y, clr_dst);
								}
								break;
							}
							if(flag)
								flag[ab_flag] = 1;
						}
					}
				}
			}
		}
	}
	else{
		BitmapData	bitmapData;
		Rect		rect(0, 0, wdh, hgt);
		
		// Bmpǂݏprbg}bv̈ƂăbN
		st = Bmp->LockBits(&rect, ImageLockModeRead | ImageLockModeWrite, fmt, &bitmapData);
		if (st == Ok)
		{
			BYTE	*pxl1 = NULL;
			UINT	stride1;	// 4byteE
			int		y2,ab_pre,ab_nxt,ab_flag;
			
			if (bitmapData.Stride > 0)
				pxl1 = (BYTE*) bitmapData.Scan0;
			else
				pxl1 = (BYTE*) bitmapData.Scan0
						+ (bitmapData.Stride)*(bitmapData.Height-1);
			
			stride1 = abs(bitmapData.Stride);
			
			for(y=0;y<hgtSpe;y++){
				for(x=0;x<wdhSpe;x++){
					Color	clr_dot;
					BmpSpe->GetPixel(x, y, &clr_dot);
					if(clr_dot.GetA()){	// A,R,G,B ̂ǂꂩ10ł͂Ȃ
						for(i=0;i<g_Spe.pos_num-1;i++){
							Point	pt_pre,pt_nxt;
							pt_pre = Get_Point_Spe(g_Spe.pos[i], x, y, wdhSpe, hgtSpe, wdh, hgt);
							pt_nxt = Get_Point_Spe(g_Spe.pos[i+1], x, y, wdhSpe, hgtSpe, wdh, hgt);
							if(bitmapData.Stride < 0)
								y2 = hgt - pt_pre.Y - 1;
							else
								y2 = pt_pre.Y;
							ab_pre = stride1 * y2 + pt_pre.X * bpp / 8;
							if(bitmapData.Stride < 0)
								y2 = hgt - pt_nxt.Y - 1;
							else
								y2 = pt_nxt.Y;
							ab_nxt = stride1 * y2 + pt_nxt.X * bpp / 8;
							
							ab_flag = pt_nxt.Y * wdh + pt_nxt.X;
							
							if(!flag_mask || (flag_mask && flag && flag[ab_flag] != 1)){
								switch(index)
								{
								case 0:	// ɂ
									{
										if(bpp == 32){
											pxl1[ab_nxt+3] = (BYTE)(prm * pxl1[ab_pre+3] + (1.0f - prm) * pxl1[ab_nxt+3]);
										}
										pxl1[ab_nxt+2] = (BYTE)(prm * pxl1[ab_pre+2] + (1.0f - prm) * pxl1[ab_nxt+2]);
										pxl1[ab_nxt+1] = (BYTE)(prm * pxl1[ab_pre+1] + (1.0f - prm) * pxl1[ab_nxt+1]);
										pxl1[ab_nxt+0] = (BYTE)(prm * pxl1[ab_pre+0] + (1.0f - prm) * pxl1[ab_nxt+0]);
									}
									break;
								case 1:	// ɂ݁ix̂݁j
									if(bpp == 32){
										pxl1[ab_nxt+3] = (BYTE)(prm * pxl1[ab_pre+3] + (1.0f - prm) * pxl1[ab_nxt+3]);
									}
									break;
								case 2:	// x
									if(bpp == 32){
										pxl1[ab_nxt+3] = (BYTE)(255 - alpha);
									}
									break;
								case 3:	// xij
									{
										int	r,g,b;
										int	prm2 = (int) prm;
										r = pxl1[ab_nxt+2] + prm2;
										g = pxl1[ab_nxt+1] + prm2;
										b = pxl1[ab_nxt+0] + prm2;
										if(r > 255)	r = 255;
										if(g > 255)	g = 255;
										if(b > 255)	b = 255;
										pxl1[ab_nxt+2] = (BYTE) r;
										pxl1[ab_nxt+1] = (BYTE) g;
										pxl1[ab_nxt+0] = (BYTE) b;
									}
									break;
								case 4:	// xij
									{
										int	r,g,b;
										int	prm2 = (int) prm;
										r = pxl1[ab_nxt+2] - prm2;
										g = pxl1[ab_nxt+1] - prm2;
										b = pxl1[ab_nxt+0] - prm2;
										if(r < 0)	r = 0;
										if(g < 0)	g = 0;
										if(b < 0)	b = 0;
										pxl1[ab_nxt+2] = (BYTE) r;
										pxl1[ab_nxt+1] = (BYTE) g;
										pxl1[ab_nxt+0] = (BYTE) b;
									}
									break;
								case 5:	// ʓxij
								case 6:	// ʓxij
									{
										float	val,sub,lum;
										int		i;
										BYTE	clr[3];
										clr[0] = pxl1[ab_nxt+0];
										clr[1] = pxl1[ab_nxt+1];
										clr[2] = pxl1[ab_nxt+2];
										lum =	(clr[0] * 0.114f) +
												(clr[1] * 0.587f) +
												(clr[2] * 0.299f) + 0.5f;
										for(i=0;i<3;i++){
											sub = (float) clr[i] - lum;
											val = (float) clr[i] + (sub / 255) * ((int)(255 + prm) - 255);
											if(val > 255){
												val = 255;
											}
											else if(val < 0){
												val = 0;
											}
											pxl1[ab_nxt+i] = (BYTE) val;
										}
									}
									break;
								}
								if(flag)
									flag[ab_flag] = 1;
							}
						}
					}
				}
			}
			
			st = Bmp->UnlockBits(&bitmapData);
			if(st != Ok){
				MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
				return st;
			}
		}
		else{
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	return st;
}// Draw_Special
