void         Msg_Cur(HWND hWnd, char *strMsg);
void         Divide_Rest(int t_ct,int d_ct,DWORD *i_z);
CLSID        Get_Mime_Type(char *p);
int          GetEncoderClsid(const WCHAR* format, CLSID* pClsid);
void         Get_PxFmtTxt(PixelFormat format, char *ss);
void         Get_RwFmtTxt(Bitmap *Bmp, char *ss);
void         Get_Guid(GUID guid, char *ss);
void         Get_Type(ULONG Type, char *ss);
Color        RefToColor(COLORREF bgr);
Color        RefToColor2(COLORREF bgr, BYTE alpha);
PALETTEENTRY RefToPe(COLORREF bgr);
DWORD        RefToArgb(COLORREF bgr);
DWORD        RefToArgb2(COLORREF bgr, BYTE alpha);
COLORREF     ArgbToRef(DWORD argb);
PALETTEENTRY ArgbToPe(DWORD argb);
IARGB        PeToIargb(PALETTEENTRY pe);
UINT         PxFmtToBpp(PixelFormat format);
void         RectToPoint(Point *pt, Rect rc);
int          atoi16(char *str);
DWORD        ArgbToBgra(DWORD argb, PixelFormat format);
DWORD        ArgbToArgbFmt(DWORD argb, PixelFormat format);
BARGB        ArgbToBargb(DWORD argb, PixelFormat format);
DWORD        BargbToArgb(BARGB bArgb, PixelFormat format);
void         Resize_Rect(Rect *rc1, Rect *rc2, int zoom, int dx, int dy, int wdh_min1, int hgt_min1);
void         Set_Rect(Rect *rc, int x, int y, int wdh, int hgt);
void         Set_RectF(RectF *rc, float x, float y, float wdh, float hgt);
RECT         RectToRECT(Rect rc);
Rect         RectFToRect(RectF rc);
void         RectToPt4(Point *pt, Rect rc);
void         Set_Pt4(Point *pt, int x1, int y1, int x2, int y2);
void         Set_Pt_Limit(Point *pt, int min_x, int min_y, int max_x, int max_y);
void         Set_ClipCursor(HWND hChild, Rect rc);
Status       GetClrPos(POINT *pt, Bitmap *Bmp, BYTE red, BYTE green, BYTE blue);
void         Set_AlphaAttr(BYTE alpha, ImageAttributes *imAtt);
void         Set_ColorRotateAttrRed(int degree, ImageAttributes *imAtt);
void         Set_ColorRotateAttrGreen(int degree, ImageAttributes *imAtt);
void         Set_ColorRotateAttrBlue(int degree, ImageAttributes *imAtt);
void         Set_ColorTranslateAttrRed(int len, ImageAttributes *imAtt);
void         Set_ColorTranslateAttrGreen(int len, ImageAttributes *imAtt);
void         Set_ColorTranslateAttrBlue(int len, ImageAttributes *imAtt);
void         Set_ColorTranslateAttrAlpha(int len, ImageAttributes *imAtt);
Status       Draw_OutLine(Graphics *g, Rect rc, Color clr1, Color clr2);
Status       Set_IconMask(Bitmap *Bmp, BITMAPINFO *pbmiA, BYTE *pAND);
Status       Alpha_Luminous(Bitmap *Bmp);
Status       Copy_Palette(Bitmap *BmpDst, Bitmap *BmpSrc);
bool         Get_FlagAlphaPalette(Bitmap *Bmp);
//bool         Set_FlagAlphaPalette(Bitmap *Bmp);
bool         Set_FlagAlphaPalette2(Bitmap *Bmp);
//bool         Is_AlphaPalette0(Bitmap *Bmp);
//Point        Center_Rect(RectF rc);
//PointF       Center_RectF(RectF rc);
//bool         IsIn_Wnd(HWND hWnd);
//void         Delete_Bmp(Bitmap *Bmp, BITMAPINFO *pbmi, BYTE *pbits);


// 3̐̓Aŏ̐Ԃ
inline int min3(int a, int b, int c)
{
	int min = a;
	if(b < min){
		min = b;
	}
	if(c < min){
		min = c;
	}
	return min;
}// min3

// 3̐̓Aő̐Ԃ
inline int max3(int a, int b, int c)
{
	int max = a;
	if(b > max){
		max = b;
	}
	if(c > max){
		max = c;
	}
	return max;
}// max3

// 3̐̓Aŏ̐ƂȂԍԂ
inline int min3n(int a, int b, int c)
{
	int min = a;
	int index = 0;
	if(b < min){
		min = b;
		index = 1;
	}
	if(c < min){
		min = c;
		index = 2;
	}
	return index;
}// min3n

// 3̐̓Aő̐ƂȂԍԂ
inline int max3n(int a, int b, int c)
{
	int max = a;
	int index = 0;
	if(b > max){
		max = b;
		index = 1;
	}
	if(c > max){
		max = c;
		index = 2;
	}
	return index;
}// max3n

// bZ[W{bNX\AJ[\ɖ߂
void Msg_Cur(HWND hWnd, char *strMsg)
{
	HCURSOR hCur = GetCursor();
	MessageBox (hWnd, strMsg, "", MB_OK);
	SetCursor(hCur);
	SetCapture(hWnd);
}// Msg_Cur

// t_ct̃f[^d_ct邽߂̔z쐬
// t_ct:f[^̐Ad_ct:Ai_z[257]:az
void Divide_Rest(int t_ct, int d_ct, DWORD *i_z)
{
	int 	i,am,sh;
	int 	a_z[256]	={0};
	UINT	d_z[256]	={0};

	sh = t_ct / d_ct;
	am = t_ct % d_ct;

	// t_ctd_ct菬Ƃ
	if(sh == 0){
		for(i=1;i<t_ct+1;i++){
			i_z[i] = i;
		}
		return;
	}

	// ]zɓɉZ
	if(am){
		for(i=0;i<d_ct;i++){
			if(!(i % (UINT)((float)(d_ct-1) / am)))
				if(i < am * (int)((float)(d_ct-1) / am)){
					a_z[i] = 1;
				}
		}
	}
	// d_zt_ct256ɕAi_zɂ܂ł̑a
	for(i=0; i<d_ct; i++){
		d_z[i] = sh;
		if(t_ct > d_ct){
			d_z[i] += a_z[i];
		}
		if(i > 0)
			i_z[i] = i_z[i-1] + d_z[i-1];
	}
	i_z[d_ct] = i_z[d_ct-1] + d_z[d_ct-1];
}// Divide_Rest

// gq CLSID 擾
CLSID Get_Mime_Type(char *p)
{
	CLSID Clsid;
	
	if(!stricmp(p,"bmp")){
		GetEncoderClsid(L"image/bmp",&Clsid);
	}
	else if(!stricmp(p,"gif")){
		GetEncoderClsid(L"image/gif",&Clsid);
	}
	else if(!stricmp(p,"jpg") || !stricmp(p,"jpeg")){
		GetEncoderClsid(L"image/jpeg",&Clsid);
	}
	else if(!stricmp(p,"png")){
		GetEncoderClsid(L"image/png",&Clsid);
	}
	else if(!stricmp(p,"tif") || !stricmp(p,"tiff")){
		GetEncoderClsid(L"image/tiff",&Clsid);
	}
	else{
		GetEncoderClsid(L"image/bmp",&Clsid);
		MessageBox(GetFocus(),"rbg}bv`ŕۑ܂","",MB_OK | MB_ICONWARNING);
	}
	
	return (Clsid);

}// Get_Mime_Type

// MIMECLSID擾
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
	UINT num  = 0; // number of image encoders
	UINT size = 0; // size of the image encoder array in bytes
	
	ImageCodecInfo* pImageCodecInfo = NULL;
	
	GetImageEncodersSize(&num, &size);
	if(size == 0)
		return -1; // Failure
	
	pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
	if(pImageCodecInfo == NULL)
		return -1; // Failure
	
	GetImageEncoders(num, size, pImageCodecInfo);
	
	for(UINT j = 0; j < num; ++j)
	{
		if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
		{
			*pClsid = pImageCodecInfo[j].Clsid;
			FREE(pImageCodecInfo);
			return j; // Success
		}
	}
	
	FREE(pImageCodecInfo);
	return -1; // Failure
}// GetEncoderClsid

// sNZtH[}bg擾
void Get_PxFmtTxt(PixelFormat format, char *ss)
{
	switch (format)
	{
	case PixelFormatMax:
		strcpy(ss,"Max");
		break;
	case PixelFormat64bppPARGB:
		strcpy(ss,"64-A16R16G16B16(OZ)");
		break;
	case PixelFormat64bppARGB:
		strcpy(ss,"64-A16R16G16B16");
		break;
	case PixelFormat48bppRGB:
		strcpy(ss,"48-R16G16B16");
		break;
	case PixelFormat32bppPARGB:
		strcpy(ss,"32-A8R8G8B8(OZ)");
		break;
	case PixelFormat32bppARGB:
		strcpy(ss,"32-A8R8G8B8");
		break;
	case PixelFormat32bppRGB:
		strcpy(ss,"32-R8G8B8");
		break;
	case PixelFormat24bppRGB:
		strcpy(ss,"24-R8G8B8");
		break;
	case PixelFormat16bppARGB1555:
		strcpy(ss,"16-A1R5G5B5");
		break;
	case PixelFormat16bppRGB565:
		strcpy(ss,"16-R5G6B5");
		break;
	case PixelFormat16bppRGB555:
		strcpy(ss,"16-R5G5B5");
		break;
	case PixelFormat16bppGrayScale:
		strcpy(ss,"16-GrayScale");
		break;
	case PixelFormat8bppIndexed:
		strcpy(ss,"8-Index");
		break;
	case PixelFormat4bppIndexed:
		strcpy(ss,"4-Index");
		break;
	case PixelFormat1bppIndexed:
		strcpy(ss,"1-Index");
		break;
	default:
		strcpy(ss,"?-?");
	}
}// Get_PxFmtTxt

// t@C`擾
void Get_RwFmtTxt(Bitmap *Bmp, char *ss)
{
	Status	st;
	GUID	guid;

	st = Bmp->GetRawFormat(&guid);
	if (st != Ok){
		MessageBox(GetFocus(),"t@C`擾ł܂","",MB_OK);
	}

	if(guid == ImageFormatBMP)
		strcpy(ss,"BMP");
	else if (guid == ImageFormatEMF)
		strcpy(ss,"EMF");
	else if (guid == ImageFormatEXIF)
		strcpy(ss,"EXIF");
	else if (guid == ImageFormatGIF)
		strcpy(ss,"GIF");
	else if (guid == ImageFormatIcon)
		strcpy(ss,"ICON");
	else if (guid == ImageFormatJPEG)
		strcpy(ss,"JPEG");
	else if (guid == ImageFormatPNG)
		strcpy(ss,"PNG");
	else if (guid == ImageFormatTIFF)
		strcpy(ss,"TIFF");
	else if (guid == ImageFormatWMF)
		strcpy(ss,"WMF");
	else if (guid == ImageFormatMemoryBMP)
		strcpy(ss,"MemoryBMP");
	else if (guid == ImageFormatUndefined)
		strcpy(ss,"-");
	else
		strcpy(ss,"-");

}// Get_RwFmtTxt

// ۑ`̃vpeB̎(GUID)̕擾
void Get_Guid(GUID Guid, char *ss)
{
	if(Guid == EncoderCompression)
		strcpy(ss,"EncoderCompression");
	else if(Guid == EncoderColorDepth)
		strcpy(ss,"EncoderColorDepth");
	else if(Guid == EncoderScanMethod)
		strcpy(ss,"EncoderScanMethod");
	else if(Guid == EncoderVersion)
		strcpy(ss,"EncoderVersion");
	else if(Guid == EncoderRenderMethod)
		strcpy(ss,"EncoderRenderMethod");
	else if(Guid == EncoderQuality)
		strcpy(ss,"EncoderEncoderQuality");
	else if(Guid == EncoderTransformation)
		strcpy(ss,"EncoderTransformation");
	else if(Guid == EncoderLuminanceTable)
		strcpy(ss,"EncoderLuminanceTable");
	else if(Guid == EncoderChrominanceTable)
		strcpy(ss,"EncoderChrominanceTable");
	else if(Guid == EncoderSaveFlag)
		strcpy(ss,"EncoderSaveFlag");
	else if(Guid == CodecIImageBytes)
		strcpy(ss,"CodecIImageBytes");
	else
		strcpy(ss,"-");
}// Get_Guid

// ۑ`̃vpeB̎(GUID)擾
void Get_Type(ULONG Type, char *ss)
{
	switch (Type)
	{
	case EncoderParameterValueTypeByte:
		strcpy(ss,"EncoderParameterValueTypeByte");
		break;
	case EncoderParameterValueTypeASCII:
		strcpy(ss,"EncoderParameterValueTypeASCII");
		break;
	case EncoderParameterValueTypeShort:
		strcpy(ss,"EncoderParameterValueTypeShort");
		break;
	case EncoderParameterValueTypeLong:
		strcpy(ss,"EncoderParameterValueTypeLong");
		break;
	case EncoderParameterValueTypeRational:
		strcpy(ss,"EncoderParameterValueTypeRational");
		break;
	case EncoderParameterValueTypeLongRange:
		strcpy(ss,"EncoderParameterValueTypeLongRange");
		break;
	case EncoderParameterValueTypeUndefined:
		strcpy(ss,"EncoderParameterValueTypeUndefined");
		break;
	case EncoderParameterValueTypeRationalRange:
		strcpy(ss,"EncoderParameterValueTypeRationalRange");
		break;
	default:
		strcpy(ss,"-");
	}
}// Get_Type

// COLORREF  Color ϊ
Color RefToColor(COLORREF bgr)
{
	return (Color::MakeARGB(255,GetRValue(bgr),GetGValue(bgr),GetBValue(bgr)));
}// RefToColor


// COLORREF  Color ϊ
// alphaFx
Color RefToColor2(COLORREF bgr, BYTE alpha)
{
	return (Color::MakeARGB(alpha,GetRValue(bgr),GetGValue(bgr),GetBValue(bgr)));
}// RefToColor2

PALETTEENTRY RefToPe(COLORREF bgr)
{
	PALETTEENTRY pe;
	
	pe.peBlue  = (BYTE)(bgr >> 16);
	pe.peGreen = (BYTE)(bgr >>  8);
	pe.peRed   = (BYTE) bgr;
	
	return (pe);
}// RefToPe

// COLORREF  (A)RGB ϊi24bit̂݁j
DWORD RefToArgb(COLORREF bgr)
{
	DWORD Argb;
	BYTE  r,g,b;
	b = (BYTE)(bgr >> 16);
	g = (BYTE)(bgr >>  8);
	r = (BYTE) bgr;
	Argb = (0xff << 24) | (r << 16) | (g << 8) | b;
	
	return (Argb);
}// RefToArgb

// COLORREF  (A)RGB ϊi32bit̂݁j
DWORD RefToArgb2(COLORREF bgr, BYTE alpha)
{
	DWORD Argb;
	BYTE  r,g,b;
	b = (BYTE)(bgr >> 16);
	g = (BYTE)(bgr >>  8);
	r = (BYTE) bgr;
	Argb = (alpha << 24) | (r << 16) | (g << 8) | b;
	
	return (Argb);
}// RefToArgb2

// (A)RGB  COLORREF ϊi24bit̂݁j
COLORREF ArgbToRef(DWORD argb)
{
	COLORREF bgr;
	BYTE     r,g,b;
	r = (BYTE)(argb >> 16);
	g = (BYTE)(argb >>  8);
	b = (BYTE) argb;
	bgr = (b << 16) | (g << 8) | r;
	return (bgr);
}// ArgbToRef

// (A)RGB  PALETTEENTRY ϊ
PALETTEENTRY ArgbToPe(DWORD argb)
{
	PALETTEENTRY pe;
	
	pe.peBlue  = (UINT)( argb        & 0xff);
	pe.peGreen = (UINT)((argb >>  8) & 0xff);
	pe.peRed   = (UINT)((argb >> 16) & 0xff);
	
	return (pe);
}// ArgbToIargb

// PALETTEENTRY  IARGB ϊ
IARGB PeToIargb(PALETTEENTRY pe)
{
	IARGB iARGB;
	
	iARGB.B = (UINT) pe.peBlue;
	iARGB.G = (UINT) pe.peGreen;
	iARGB.R = (UINT) pe.peRed;
	iARGB.A = 255;
	
	return (iARGB);
}// ArgbToIargb

// sNZtH[}bg  J[fvX ϊ
UINT PxFmtToBpp(PixelFormat format)
{
	return ((BYTE)(format >> 8));
}

// Rect rc[4]  Point pt[4] ϊ
void RectToPoint(Point *pt, Rect rc)
{
	int pt_x[] = {0, rc.Width, 0, rc.Width};
	int pt_y[] = {0, 0, rc.Height, rc.Height};

	for(int i=0; i<4; i++){
		pt[i].X = pt_x[i];
		pt[i].Y = pt_y[i];
	}
}// RectToPoint

// 16i̕10i̐lɕϊ
int atoi16(char *str)
{
	int i,k,add = 0;
	int len = strlen(str);
	for(i=len-1;i>=0;i--){
		if     (str[i] == '0')	k = 0;
		else if(str[i] == '1')	k = 1;
		else if(str[i] == '2')	k = 2;
		else if(str[i] == '3')	k = 3;
		else if(str[i] == '4')	k = 4;
		else if(str[i] == '5')	k = 5;
		else if(str[i] == '6')	k = 6;
		else if(str[i] == '7')	k = 7;
		else if(str[i] == '8')	k = 8;
		else if(str[i] == '9')	k = 9;
		else if(str[i] == 'a')	k = 10;
		else if(str[i] == 'b')	k = 11;
		else if(str[i] == 'c')	k = 12;
		else if(str[i] == 'd')	k = 13;
		else if(str[i] == 'e')	k = 14;
		else if(str[i] == 'f')	k = 15;
		else	continue;
		add += k * (int)pow(16,(len-i-1));
	}
	
	return add;
}// atoi16

// ARGB  BGRA ϊ
DWORD ArgbToBgra(DWORD argb, PixelFormat format)
{
	DWORD bgra = 0;
	
	switch (format)
	{
	case PixelFormatMax:
	case PixelFormat64bppPARGB:
	case PixelFormat64bppARGB:
	case PixelFormat48bppRGB:
		break;
	case PixelFormat32bppPARGB:
	case PixelFormat32bppARGB:
		bgra |= ((argb >> 24) & 0xff);
		bgra |= ((argb >> 16) & 0xff) <<  8;
		bgra |= ((argb >>  8) & 0xff) << 16;
		bgra |= ( argb        & 0xff) << 24;
		break;
	case PixelFormat32bppRGB:
	case PixelFormat24bppRGB:
		bgra |= ((argb >> 16) & 0xff);
		bgra |= ((argb >>  8) & 0xff) <<  8;
		bgra |= ( argb        & 0xff) << 16;
		break;
	case PixelFormat16bppARGB1555:
		bool flag;
		argb >> 24 ? flag = 1 : flag = 0;
		bgra |= flag << 15;
		bgra |= ((argb >> 19) & 0x1f) << 10;
		bgra |= ((argb >> 11) & 0x1f) <<  5;
		bgra |= ( argb        & 0x1f);
		break;
	case PixelFormat16bppRGB565:
		bgra |= ((argb >> 19) & 0x1f) << 11;
		bgra |= ((argb >> 10) & 0x3f) <<  5;
		bgra |= ( argb        & 0x1f);
		break;
	case PixelFormat16bppRGB555:
		bgra |= ((argb >> 19) & 0x1f) << 10;
		bgra |= ((argb >> 11) & 0x1f) <<  5;
		bgra |= ( argb        & 0x1f);
		break;
	}
	return (bgra);
}// ArgbToBgra

// ARGB  ARGB Format ϊ
DWORD ArgbToArgbFmt(DWORD argb, PixelFormat format)
{
	BYTE  a,r,g,b;
	DWORD fArgb = 0;
	
	switch (format)
	{
	case PixelFormatMax:
	case PixelFormat64bppPARGB:
	case PixelFormat64bppARGB:
	case PixelFormat48bppRGB:
		fArgb = 0;
		break;
	case PixelFormat32bppPARGB:
	case PixelFormat32bppARGB:
		fArgb = argb;
		break;
	case PixelFormat32bppRGB:
	case PixelFormat24bppRGB:
		fArgb = argb | 0xff000000;
		break;
	case PixelFormat16bppARGB1555:
		bool flag;
		argb >> 24 ? flag = 1 : flag = 0;
		a = (BYTE) flag;
		r = (BYTE)((argb >> 19) & 0x1f);
		g = (BYTE)((argb >> 11) & 0x1f);
		b = (BYTE)((argb >>  3) & 0x1f);
		fArgb = a << 15 | r << 10 | g << 5 | b;
		break;
	case PixelFormat16bppRGB565:
		r = (BYTE)((argb >> 19) & 0x1f);
		g = (BYTE)((argb >> 10) & 0x3f);
		b = (BYTE)((argb >>  3) & 0x1f);
		fArgb = r << 11 | g << 5 | b;
		break;
	case PixelFormat16bppRGB555:
		r = (BYTE)((argb >> 19) & 0x1f);
		g = (BYTE)((argb >> 11) & 0x1f);
		b = (BYTE)((argb >>  3) & 0x1f);
		fArgb = r << 10 | g << 5 | b;
		break;
	}
	return (fArgb);
}// ArgbToArgbFmt

// ARGB  BARGBϊ
BARGB ArgbToBargb(DWORD argb, PixelFormat format)
{
	BARGB bArgb;
	switch (format)
	{
	case PixelFormat32bppPARGB:
	case PixelFormat32bppARGB:
		bArgb.B = (BYTE) argb;
		bArgb.G = (BYTE)(argb >>  8);
		bArgb.R = (BYTE)(argb >> 16);
		bArgb.A = (BYTE)(argb >> 24);
		break;
	case PixelFormat32bppRGB:
	case PixelFormat24bppRGB:
		bArgb.B = (BYTE) argb;
		bArgb.G = (BYTE)(argb >>  8);
		bArgb.R = (BYTE)(argb >> 16);
		bArgb.A = 0xff;
		break;
	case PixelFormat16bppARGB1555:
		bArgb.B = (BYTE)( argb        & 0x1f) << 3;
		bArgb.G = (BYTE)((argb >>  5) & 0x1f) << 3;
		bArgb.R = (BYTE)((argb >> 10) & 0x1f) << 3;
		bArgb.A = (BYTE)((argb >> 15) & 1) * 0xff;
		break;
	case PixelFormat16bppRGB565:
		bArgb.B = (BYTE)( argb        & 0x1f) << 3;
		bArgb.G = (BYTE)((argb >>  5) & 0x3f) << 2;
		bArgb.R = (BYTE)((argb >> 11) & 0x1f) << 3;
		bArgb.A = 0xff;
		break;
	case PixelFormat16bppRGB555:
		bArgb.B = (BYTE)( argb        & 0x1f) << 3;
		bArgb.G = (BYTE)((argb >>  5) & 0x1f) << 3;
		bArgb.R = (BYTE)((argb >> 10) & 0x1f) << 3;
		bArgb.A = 0xff;
		break;
	default:
		bArgb.B = 0;
		bArgb.G = 0;
		bArgb.R = 0;
		bArgb.A = 0xff;
		break;
	}
	return (bArgb);
}// ArgbToBargb

// BARGB  ARGBϊ
DWORD BargbToArgb(BARGB bArgb, PixelFormat format)
{
	DWORD argb = 0;
	switch (format)
	{
	case PixelFormat32bppPARGB:
	case PixelFormat32bppARGB:
		argb = bArgb.A << 24 | bArgb.R << 16 | bArgb.G << 8 | bArgb.B;
		break;
	case PixelFormat32bppRGB:
	case PixelFormat24bppRGB:
		argb = 0xff000000 | bArgb.R << 16 | bArgb.G << 8 | bArgb.B;
		break;
	case PixelFormat16bppARGB1555:
		BYTE flag;
		bArgb.A ? flag = 1 : flag = 0;
		argb = flag << 15 | (bArgb.R >> 3) << 10 | (bArgb.G >> 3) << 5 | bArgb.B >> 3;
		break;
	case PixelFormat16bppRGB565:
		argb = (bArgb.R >> 3) << 11 | (bArgb.G >> 2) << 5 | bArgb.B >> 3;
		break;
	case PixelFormat16bppRGB555:
		argb = (bArgb.R >> 3) << 10 | (bArgb.G >> 3) << 5 | bArgb.B >> 3;
		break;
	default:
		argb = 0;
		break;
	}
	return (argb);
}// BargbToArgb

void Resize_Rect(Rect *rc1, Rect *rc2, int zoom, int dx, int dy, int wdh_min1, int hgt_min1)
{
	if(rc1->Width < wdh_min1){
		rc1->Width += dx;
		rc2->Width += dx * zoom / 100;
	}
	if(rc1->Height < hgt_min1){
		rc1->Height += dy;
		rc2->Height += dy * zoom / 100;
	}
}// Resize_Rect

void Set_Rect(Rect *rc, int x, int y, int wdh, int hgt)
{
	rc->X      = x;
	rc->Y      = y;
	rc->Width  = wdh;
	rc->Height = hgt;
}// Set_Rect

void Set_RectF(RectF *rc, float x, float y, float wdh, float hgt)
{
	rc->X      = x;
	rc->Y      = y;
	rc->Width  = wdh;
	rc->Height = hgt;
}// Set_RectF

RECT RectToRECT(Rect rc)
{
    RECT rc2;
	SetRect(&rc2, rc.X, rc.Y, rc.Width, rc.Height);
	return rc2;
}// RectToRECT

Rect RectFToRect(RectF rc)
{
	Rect rc2;
	Set_Rect(&rc2, (int)rc.X, (int)rc.Y, (int)rc.Width, (int)rc.Height);
	return rc2;
}// RectFToRect

void RectToPt4(Point *pt, Rect rc)
{
	pt[0] = Point(rc.X,     rc.Y);
	pt[1] = Point(rc.X,     rc.Height);
	pt[2] = Point(rc.Width, rc.Height);
	pt[3] = Point(rc.Width, rc.Y);
}// RectToPt4

void Set_Pt4(Point *pt, int x1, int y1, int x2, int y2)
{
	pt[0] = Point(x1, y1);
	pt[1] = Point(x1, y2);
	pt[2] = Point(x2, y2);
	pt[3] = Point(x2, y1);
}// Set_Pt4

void Set_Pt_Limit(Point *pt, int min_x, int min_y, int max_x, int max_y)
{
	if(pt->X < min_x)
		pt->X = min_x;
	else if(pt->X > max_x)
		pt->X = max_x;
	if(pt->Y < min_y)
		pt->Y = min_y;
	else if(pt->Y > max_y)
		pt->Y = max_y;
}// Set_Pt_Limit

void Set_ClipCursor(HWND hChild, Rect rc_Clip)
{
	RECT rc;
	POINT pt[2];
	pt[0].x = rc_Clip.X;
	pt[0].y = rc_Clip.Y;
	pt[1].x = rc_Clip.X+rc_Clip.Width;
	pt[1].y = rc_Clip.Y+rc_Clip.Height;
	MapWindowPoints(hChild, NULL, pt, 2);
	SetRect(&rc, pt[0].x, pt[0].y, pt[1].x, pt[1].y);
	ClipCursor(&rc);
}// Set_ClipCursor

// w肵FŏɌʒuԂ
Status GetClrPos(POINT *pt, Bitmap *Bmp, BYTE red, BYTE green, BYTE blue)
{
	Status		st = GenericError;
	BitmapData	bitmapData;
	UINT		wdh = Bmp->GetWidth();
	UINT		hgt = Bmp->GetHeight();
	Rect		rect(0, 0, wdh, hgt);
	
	// Bmp32bittH[}bg̓ǂݍݐprbg}bv̈ƂăbN
	st = Bmp->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels1 = NULL;
		UINT	stride1;	// 4byteE
		UINT	x,y,ab;
		
		if (bitmapData.Stride > 0)
			pixels1 = (BYTE*) bitmapData.Scan0;
		else
			pixels1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		for(y=0; y<hgt; y++){
			for(x=0; x<wdh; x++){
				ab = stride1*y+x*4;
				if( pixels1[ab+2] == red   &&
					pixels1[ab+1] == green &&
					pixels1[ab+0] == blue ){
					pt->x = x;
					pt->y = y;
					goto end;
				}
			}
		}
end:	st = Bmp->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		return st;
	}
	return st;
}// GetClrPos

// x̐ݒ
void Set_AlphaAttr(BYTE alpha, ImageAttributes *imAtt)
{
	ColorMatrix colorMatrix = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f,
								0.0f, 1.0f, 0.0f, 0.0f, 0.0f,
						        0.0f, 0.0f, 1.0f, 0.0f, 0.0f,
							    0.0f, 0.0f,	0.0f, (float)alpha/255, 0.0f,
							    0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
	imAtt->SetColorMatrix(&colorMatrix, ColorMatrixFlagsDefault, ColorAdjustTypeBitmap);
}// Set_AlphaAttr

// F̉]iԁj̐ݒ
void Set_ColorRotateAttrRed(int degree, ImageAttributes *imAtt)
{
	if(degree < 0)			degree = 0;
	else if(degree > 360)	degree = 360;
	
	double			rad = (double) degree * 3.1415926535 / 180;
	ColorMatrix		colorMatrix = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f,
									0.0f, (float) cos(rad), (float) sin(rad), 0.0f, 0.0f,
				        			0.0f, (float)-sin(rad), (float) cos(rad), 0.0f, 0.0f,
					    			0.0f, 0.0f,	0.0f, 1.0f, 0.0f,
					    			0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
	imAtt->SetColorMatrix(&colorMatrix, ColorMatrixFlagsDefault, ColorAdjustTypeBitmap);
}// Set_ColorRotateAttrRed

// F̉]i΁j̐ݒ
void Set_ColorRotateAttrGreen(int degree, ImageAttributes *imAtt)
{
	if(degree < 0)			degree = 0;
	else if(degree > 360)	degree = 360;
	
	double			rad = (double) degree * 3.1415926535 / 180;
	ColorMatrix		colorMatrix = { (float) cos(rad), 0.0f, (float)-sin(rad), 0.0f, 0.0f,
									0.0f, 1.0f, 0.0f, 0.0f, 0.0f,
									(float) sin(rad), 0.0f, (float) cos(rad), 0.0f, 0.0f,
					    			0.0f, 0.0f,	0.0f, 1.0f, 0.0f,
					    			0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
	imAtt->SetColorMatrix(&colorMatrix, ColorMatrixFlagsDefault, ColorAdjustTypeBitmap);
}// Set_ColorRotateAttrGreen

// F̉]ij̐ݒ
void Set_ColorRotateAttrBlue(int degree, ImageAttributes *imAtt)
{
	if(degree < 0)			degree = 0;
	else if(degree > 360)	degree = 360;
	
	double			rad = (double) degree * 3.1415926535 / 180;
	ColorMatrix		colorMatrix = { (float) cos(rad), (float) sin(rad), 0.0f, 0.0f, 0.0f,
									(float)-sin(rad), (float) cos(rad), 0.0f, 0.0f, 0.0f,
				        			0.0f, 0.0f, 1.0f, 0.0f, 0.0f,
					    			0.0f, 0.0f,	0.0f, 1.0f, 0.0f,
					    			0.0f, 0.0f, 0.0f, 0.0f, 1.0f };
	imAtt->SetColorMatrix(&colorMatrix, ColorMatrixFlagsDefault, ColorAdjustTypeBitmap);
}// Set_ColorRotateAttrBlue

// F̕sړiԁj̐ݒ
void Set_ColorTranslateAttrRed(int len, ImageAttributes *imAtt)
{
	if(len < 0)			len = 0;
	else if(len > 100)	len = 100;
	
	ColorMatrix	colorMatrix = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f,
								0.0f, 1.0f, 0.0f, 0.0f, 0.0f,
				       			0.0f, 0.0f, 1.0f, 0.0f, 0.0f,
				    			0.0f, 0.0f,	0.0f, 1.0f, 0.0f,
				    			(float) len / 100, 0.0f, 0.0f, 0.0f, 1.0f };
	imAtt->SetColorMatrix(&colorMatrix, ColorMatrixFlagsDefault, ColorAdjustTypeBitmap);
}// Set_ColorTranslateAttrRed

// F̕sړi΁j̐ݒ
void Set_ColorTranslateAttrGreen(int len, ImageAttributes *imAtt)
{
	if(len < 0)			len = 0;
	else if(len > 100)	len = 100;
	
	ColorMatrix	colorMatrix = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f,
								0.0f, 1.0f, 0.0f, 0.0f, 0.0f,
				       			0.0f, 0.0f, 1.0f, 0.0f, 0.0f,
				    			0.0f, 0.0f,	0.0f, 1.0f, 0.0f,
				    			0.0f, (float) len / 100, 0.0f, 0.0f, 1.0f };
	imAtt->SetColorMatrix(&colorMatrix, ColorMatrixFlagsDefault, ColorAdjustTypeBitmap);
}// Set_ColorTranslateAttrGreen

// F̕sړij̐ݒ
void Set_ColorTranslateAttrBlue(int len, ImageAttributes *imAtt)
{
	if(len < 0)			len = 0;
	else if(len > 100)	len = 100;
	
	ColorMatrix	colorMatrix = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f,
								0.0f, 1.0f, 0.0f, 0.0f, 0.0f,
				       			0.0f, 0.0f, 1.0f, 0.0f, 0.0f,
				    			0.0f, 0.0f,	0.0f, 1.0f, 0.0f,
				    			0.0f, 0.0f, (float) len / 100, 0.0f, 1.0f };
	imAtt->SetColorMatrix(&colorMatrix, ColorMatrixFlagsDefault, ColorAdjustTypeBitmap);
}// Set_ColorTranslateAttrBlue

// F̕sړixj̐ݒ
void Set_ColorTranslateAttrAlpha(int len, ImageAttributes *imAtt)
{
	if(len < 0)			len = 0;
	else if(len > 100)	len = 100;
	
	ColorMatrix	colorMatrix = { 1.0f, 0.0f, 0.0f, 0.0f, 0.0f,
								0.0f, 1.0f, 0.0f, 0.0f, 0.0f,
				       			0.0f, 0.0f, 1.0f, 0.0f, 0.0f,
				    			0.0f, 0.0f,	0.0f, 1.0f, 0.0f,
				    			0.0f, 0.0f, 0.0f, (float) len / 100, 1.0f };
	imAtt->SetColorMatrix(&colorMatrix, ColorMatrixFlagsDefault, ColorAdjustTypeBitmap);
}// Set_ColorTranslateAttrAlpha

// 摜̊Og̕`
Status Draw_OutLine(Graphics *g, Rect rc, Color clr1, Color clr2)
{
	Status st = GenericError;
	
	Pen pen1(clr1);
	Pen pen2(clr2);
	st = pen2.SetDashStyle(DashStyleDot);
	st = g->DrawRectangle(&pen1, rc);
	st = g->DrawRectangle(&pen2, rc);
	
	return st;
}// Draw_OutLine

// ACR摜Ƀ}XNݒ肷
Status Set_IconMask(Bitmap *Bmp, BITMAPINFO *pbmiA, BYTE *pAND)
{
	Status st = GenericError;
	
	if(!Bmp || !pbmiA || !pAND){
		return st;
	}
	
	Bitmap Bmp2(pbmiA, pAND);
	Color clr,clr2;
	for(UINT y=0; y<Bmp->GetHeight(); y++){
		for(UINT x=0; x<Bmp->GetWidth(); x++){
			Bmp2.GetPixel(x, y, &clr2);
			if(clr2.GetR()){
				ARGB argb = 0;
				clr.SetValue(argb);
				Bmp->SetPixel(x, y, clr);
			}
		}
	}
	
	st = Bmp->GetLastStatus();
	st = Bmp2.GetLastStatus();
	
	return st;
}// Set_IconMask

// x𖾓xɕϊ
// Bmp        : ǂݍݗprbg}bvIuWFNg
Status Alpha_Luminous(Bitmap *Bmp)
{
	Status		st = GenericError;
	
	if(!Bmp){
		return st;
	}
	
	BitmapData	bitmapData;
	UINT		wdh  = Bmp->GetWidth();
	UINT		hgt  = Bmp->GetHeight();
	PixelFormat	pfmt = Bmp->GetPixelFormat();
	UINT		bpp  = PxFmtToBpp(pfmt);
	Rect		rect(0, 0, wdh, hgt);
	
	if(bpp != 32){
		MessageBox(GetFocus(),"32bit 摜pł","",MB_OK);
		return st;
	}
	
	st = Bmp->LockBits(&rect, ImageLockModeRead | ImageLockModeWrite, pfmt, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pxl1 = NULL;
		UINT	stride1;	// 4byteE
		UINT	x,y,ab1;
		
		if (bitmapData.Stride > 0)
			pxl1 = (BYTE*) bitmapData.Scan0;
		else
			pxl1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		
		stride1 = abs(bitmapData.Stride);
		
		for(y=0;y<hgt;y++){
			for(x=0;x<wdh;x++){
				ab1 = stride1*y+x*bpp/8;
				pxl1[ab1+0] = pxl1[ab1+1] = pxl1[ab1+2] = pxl1[ab1+3];
				pxl1[ab1+3] = 255;
			}
		}
		st = Bmp->UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		}
	}
	else{
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
	}
	
	return st;
}// Alpha_Luminous

// pbg̃Rs[
Status Copy_Palette(Bitmap *BmpDst, Bitmap *BmpSrc)
{
	Status st = GenericError;
	
	if(BmpDst && BmpSrc && BmpSrc->GetPixelFormat() & PixelFormatIndexed){
		ColorPalette	*ppal = NULL;
		int 			p_sz = BmpSrc->GetPaletteSize();
		ppal = (ColorPalette *) new BYTE [p_sz];
		if(ppal){
			ZeroMemory(ppal, sizeof(ppal));
			st = BmpSrc->GetPalette(ppal, p_sz);
			if(st == Ok){
				st = BmpDst->SetPalette(ppal);
			}
		}
		SAFE_DELETE_ARRAY_BYTE(ppal);
	}
	else{
		return Ok;
	}
	
	return st;
}// Copy_Palette

// pbgɓxݒ肳Ă TRUE Ԃ
bool Get_FlagAlphaPalette(Bitmap *Bmp)
{
	ColorPalette	*ppal;
	bool			flag = false;
	
	if(!Bmp || !(Bmp->GetPixelFormat() & PixelFormatIndexed)){
		return flag;
	}
	
	// pbg̎擾
	UINT p_sz = Bmp->GetPaletteSize();
	if(p_sz){
		ppal = (ColorPalette *)new BYTE[p_sz];
		if(ppal != NULL){
			ZeroMemory(ppal, p_sz);
			if(Ok != Bmp->GetPalette(ppal, p_sz)){
				SAFE_DELETE_ARRAY_BYTE(ppal);
				return flag;
			}
		}
	}
	
	if(ppal && ppal->Flags == PaletteFlagsHasAlpha){
		flag = true;
	}
	
	SAFE_DELETE_ARRAY_BYTE(ppal);
	
	return flag;
}// Get_FlagAlphaPalette
/*
// pbgɃAt@tOݒ
bool Set_FlagAlphaPalette(Bitmap *Bmp)
{
	ColorPalette	*ppal;
	bool			flag = false;
	
	if(!(Bmp->GetPixelFormat() & PixelFormatIndexed)){
		return true;
	}
	
	// pbg̎擾
	UINT p_sz = Bmp->GetPaletteSize();
	if(p_sz){
		ppal = (ColorPalette *)new BYTE[p_sz];
		if(ppal != NULL){
			ZeroMemory(ppal, p_sz);
			if(Ok != Bmp->GetPalette(ppal, p_sz)){
				SAFE_DELETE_ARRAY_BYTE(ppal);
			}
		}
	}
	
	if(ppal){
		ppal->Flags |= PaletteFlagsHasAlpha;
		// pbg̐ݒ
		if(Ok == Bmp->SetPalette(ppal)){
			flag = true;
		}
	}
	
	SAFE_DELETE_ARRAY_BYTE(ppal);
	
	return flag;
}// Set_FlagAlphaPalette
*/
// pbgɃAt@l[AAt@tOݒ
bool Set_FlagAlphaPalette2(Bitmap *Bmp)
{
	ColorPalette	*ppal;
	bool			flag = false;
	
	if(!(Bmp->GetPixelFormat() & PixelFormatIndexed)){
		return true;
	}
	
	// pbg̎擾
	UINT p_sz = Bmp->GetPaletteSize();
	if(p_sz){
		ppal = (ColorPalette *)new BYTE[p_sz];
		if(ppal != NULL){
			ZeroMemory(ppal, p_sz);
			if(Ok != Bmp->GetPalette(ppal, p_sz)){
				SAFE_DELETE_ARRAY_BYTE(ppal);
			}
		}
	}
	
	if(ppal){
		// eF̃At@l𒲂ׂ
		bool flag_Alpha = false;
		for(int i=0; i<(int)ppal->Count; i++){
			if((ppal->Entries[i] >> 24) == 0){
				flag_Alpha = true;
				break;
			}
		}
		// At@tOǉ
		if(flag_Alpha){
			ppal->Flags |= PaletteFlagsHasAlpha;
		}
		else{
			ppal->Flags &= !PaletteFlagsHasAlpha;
		}
		
		// pbg̐ݒ
		if(Ok == Bmp->SetPalette(ppal)){
			flag = true;
		}
	}
	
	SAFE_DELETE_ARRAY_BYTE(ppal);
	
	return flag;
}// Set_FlagAlphaPalette2
/*
// pbgɃAt@l[Atrue Ԃ
bool Is_AlphaPalette0(Bitmap *Bmp)
{
	ColorPalette	*ppal;
	bool			flag_Alpha = false;
	
	if(!(Bmp->GetPixelFormat() & PixelFormatIndexed)){
		return flag_Alpha;
	}
	
	// pbg̎擾
	UINT p_sz = Bmp->GetPaletteSize();
	if(p_sz){
		ppal = (ColorPalette *)new BYTE[p_sz];
		if(ppal != NULL){
			ZeroMemory(ppal, p_sz);
			if(Ok != Bmp->GetPalette(ppal, p_sz)){
				SAFE_DELETE_ARRAY_BYTE(ppal);
			}
		}
	}
	
	if(ppal){
		// eF̃At@l𒲂ׂ
		for(int i=0; i<(int)ppal->Count; i++){
			if((ppal->Entries[i] >> 24) == 0){
				flag_Alpha = true;
				break;
			}
		}
	}
	
	SAFE_DELETE_ARRAY_BYTE(ppal);
	
	return flag_Alpha;
}// Is_AlphaPalette0

Point Center_Rect(Rect rc)
{
	Point pt;
	pt.X = rc.X + rc.Width  / 2;
	pt.Y = rc.Y + rc.Height / 2;
	return pt;
}// Center_Rect

PointF Center_RectF(RectF rc)
{
	PointF pt;
	pt.X = rc.X + rc.Width  / 2;
	pt.Y = rc.Y + rc.Height / 2;
	return pt;
}// Center_RectF

// }EXJ[\wEBhEɂ邩
bool IsIn_Wnd(HWND hWnd)
{
	POINT	pt;
	RECT	rcChild;
	GetCursorPos(&pt);
	ScreenToClient(hWnd, &pt);
	GetClientRect(hWnd, &rcChild);
	if(pt.x >= 0 && pt.x < rcChild.right && pt.y >= 0 && pt.y < rcChild.bottom){
		return true;
	}
	return false;
}// IsIn_Wnd

// BITMAPINFO 쐬摜IuWFNg̍폜
void Delete_Bmp(Bitmap *Bmp, BITMAPINFO *pbmi, BYTE *pbits)
{
	SAFE_DELETE_OBJ(Bmp);
	SAFE_DELETE_ARRAY_BYTE(pbmi);
	SAFE_DELETE_ARRAY(pbits);
}// Delete_Bmp

*/