// Thumbs		10000 `
// sN`		1456 `
// Child		1524 `
// StatusBar	1540 `
// Rebar		1556 `
// Tool			1572 `
// Combo		1588 `
// ComboEx		1620 `
// Static		1652 `
// Slider		1684 `
// Spin			1700 `
// CheckBox		1716 `
// Pager		1732 `

HMENU		g_hMenu		= NULL;
char		filename2[256][MAX_PATH];
int			FN_ct = 0;

// Rg[̈ʒuƃTCY
typedef struct{
	int x,y,wdh,hgt;
}CSIZE,*LPCSIZE;

void	Set_Class_Child(char *cls, WNDPROC ProcWnd);
HWND	Set_Child(HWND hWnd, char *cls, DWORD exStyle);
HWND	Set_StatusBar(HWND hWnd);
HWND	Set_Rebar(HWND hWnd, bool flag_Vert);
HWND	Set_Tool(HWND hWnd, bool flag_Vert);
HWND	Set_Combo(HWND hParent, CSIZE sz);
HWND	Set_ComboEx(HWND hParent, CSIZE sz);
HWND	Set_Static(HWND hParent, CSIZE sz, char *text, bool flag_Vert);
HWND	Set_Edit(HWND hParent, CSIZE sz, UINT id_edit, bool flag_Vert);
HWND	Set_Slider(HWND hParent, CSIZE sz);
HWND	Set_Spin(HWND hParent, CSIZE sz, bool flag_Vert);
HWND	Set_CheckBox(HWND hParent, CSIZE sz, char *text);
HWND	Set_Pager(HWND hWnd, bool flag_Vert);
void	Split_Filename(char *FName);
bool	Menu_Toggle_Check(UINT id);
void	Menu_Check(HMENU hMenu, UINT id, bool flag_check);
CSIZE	Set_Csize(int x, int y, int wdh, int hgt);
SIZE	Get_StrSize(HWND hWnd, HGDIOBJ sobj, char *str);
bool	IsVisible_Band(HWND hRebar, int index);
void	Change_ListBoxItem(HWND hDlg, int id_list, int new_pos);
void	Delete_ListBoxItem(HWND hDlg, int id_list);

// qEBhENX̓o^
void Set_Class_Child(char *cls, WNDPROC ProcWnd)
{
	WNDCLASSEX wc;
	
	// qEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= GetModuleHandle(NULL);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.style			= CS_DBLCLKS;
	wc.lpszClassName	= cls;
	RegisterClassEx(&wc);
	
}// Set_Class_Child

// qEBhE̍쐬
HWND Set_Child(HWND hWnd, char *cls, DWORD exStyle)
{
	static int k = 0;
	
	HWND hChild = CreateWindowEx(
				exStyle,
				cls,
				NULL,
				WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
				0, 0, 0, 0,
				hWnd,
				(HMENU) 1524 + k++,
				GetModuleHandle(NULL),
				NULL);
	return (hChild);
}// Set_Child

// Xe[^Xo[̍쐬
HWND Set_StatusBar(HWND hWnd)
{
	static int k = 0;
	HWND hStatus = CreateWindowEx(0,
					STATUSCLASSNAME,
					NULL,
					SBARS_SIZEGRIP | WS_CHILD | WS_VISIBLE,
					0, 0, 0, 0,
					hWnd,
					(HMENU) 1540 + k++,
					GetModuleHandle(NULL),
					NULL);
	return (hStatus);
}// Set_StatusBar

// o[Rg[̍쐬
// flag_VertFc^  1A^  0
HWND Set_Rebar(HWND hWnd, bool flag_Vert)
{
	UINT style;
	if(flag_Vert){
		style = CCS_VERT;
	}
	else{
		style = RBS_FIXEDORDER | RBS_AUTOSIZE;
	}
	REBARINFO				rbi;
	static int k = 0;
	HWND hRebar = CreateWindowEx(0,
								REBARCLASSNAME,
								NULL,
								WS_BORDER |
								WS_CHILD |
								WS_VISIBLE |
								WS_CLIPCHILDREN |
								WS_CLIPSIBLINGS |
								RBS_BANDBORDERS | 
								CCS_NODIVIDER | 
								CCS_NOPARENTALIGN |
								style,
								0, 0, 0, 0,
								hWnd,
								(HMENU) 1556 + k++,
								GetModuleHandle(NULL),
								NULL);
	
	rbi.cbSize	= sizeof(REBARINFO);
	rbi.fMask	= 0;
	rbi.himl	= (HIMAGELIST)NULL;
	SendMessage(hRebar, RB_SETBARINFO, 0, (LPARAM)&rbi);
	return (hRebar);
}// Set_Rebar

// c[o[̍쐬
// flag_VertFc^  1A^  0
HWND Set_Tool(HWND hWnd, bool flag_Vert)
{
	UINT style;
	if(flag_Vert){
		style = CCS_VERT;
	}
	else{
		style = 0;
	}
	static int k = 0;
	HWND hTool = CreateWindowEx(0,
								TOOLBARCLASSNAME,
								NULL,
								WS_CHILD | 
								WS_CLIPCHILDREN | 
								WS_VISIBLE |
								TBSTYLE_TOOLTIPS | 
								TBSTYLE_FLAT | 
								TBSTYLE_WRAPABLE | 
								CCS_NORESIZE | 
								CCS_NODIVIDER | 
								style,
								0,0,0,0,
								hWnd,
								(HMENU) 1572 + k++,
								GetModuleHandle(NULL),
								NULL);
	SendMessage(hTool, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);
	return (hTool);
}// Set_Tool

// R{{bNX̍쐬
HWND Set_Combo(HWND hParent, CSIZE sz)
{
	static int k = 0;
	HWND hComb = CreateWindowEx(0,
								"COMBOBOX",
								NULL,
								WS_CHILD | WS_TABSTOP | WS_VISIBLE | CBS_DROPDOWNLIST | WS_VSCROLL,
								sz.x, sz.y, sz.wdh, sz.hgt,
								hParent,
								(HMENU) 1588 + k++,
								GetModuleHandle(NULL),
								NULL);
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL){
		SendMessage(hComb, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
		DeleteObject(sobj);
	}
	return (hComb);
}// Set_Combo

// gR{{bNX̍쐬
HWND Set_ComboEx(HWND hParent, CSIZE sz)
{
	static int k = 0;
	HWND hComb = CreateWindowEx(0,
								WC_COMBOBOXEX,
								NULL,
								WS_CHILD | WS_TABSTOP | WS_VISIBLE | CBS_DROPDOWNLIST | WS_VSCROLL,
								sz.x, sz.y, sz.wdh, sz.hgt,
								hParent,
								(HMENU) 1620 + k++,
								GetModuleHandle(NULL),
								NULL);
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL){
		SendMessage(hComb, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
		DeleteObject(sobj);
	}
	return (hComb);
}// Set_ComboEx

// X^eBbNRg[̍쐬
HWND Set_Static(HWND hParent, CSIZE sz, char *text, bool flag_Vert)
{
	CSIZE sz_st;
	if(flag_Vert){
		sz_st = Set_Csize(sz.y, sz.x, sz.hgt, 0);
	}
	else{
		sz_st = Set_Csize(sz.x, sz.y, 0, sz.hgt);
	}

	static int k = 0;
	HWND hStatic = CreateWindowEx(0,
								"STATIC",
								text,
								SS_LEFT | WS_CHILD | WS_VISIBLE,
								0, 0, 0, 0,
								hParent,
								(HMENU) 1652 + k++,
								GetModuleHandle(NULL),
								NULL);
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj)
		SendMessage(hStatic, WM_SETFONT, (WPARAM) sobj, MAKELPARAM(TRUE, 0));
	// \ʒu̐ݒ
	if(sobj){
		SIZE size;
		size = Get_StrSize(hStatic, sobj, text);
		if(flag_Vert){
			sz_st.x = (sz_st.wdh - size.cx) / 2;
			if(sz_st.x < 0)	sz_st.x = 0;
		}
		else{
			sz_st.y = (sz_st.hgt - size.cy) / 2;
			if(sz_st.y < 0)	sz_st.y = 0;
		}
		MoveWindow(hStatic, sz_st.x, sz_st.y, size.cx, size.cy, FALSE);
	}
	
	return (hStatic);
}// Set_Static

// GfBbg̍쐬
// flag_VertFc^  1A^  0
HWND Set_Edit(HWND hParent, CSIZE sz, UINT id_edit, bool flag_Vert)
{
	UINT style,styleEx;
	CSIZE sz_e;
	if(flag_Vert){
		style = ES_READONLY;
		styleEx = 0;
		sz_e = Set_Csize(sz.y, sz.x, sz.hgt, 20);
	}
	else{
		style = 0;
		styleEx = WS_EX_CLIENTEDGE;
		sz_e = Set_Csize(sz.x, sz.y, sz.wdh, sz.hgt);
	}
	
	HWND hEdit = CreateWindowEx(styleEx,
				"EDIT",
				NULL,
				WS_CHILD | WS_TABSTOP | WS_VISIBLE | ES_RIGHT | style,
				sz_e.x, sz_e.y, sz_e.wdh, sz_e.hgt,
				hParent,
				(HMENU) id_edit,
				GetModuleHandle(NULL),
				NULL);
	
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL){
		SendMessage(hEdit, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
		DeleteObject(sobj);
	}
	
	return (hEdit);
}// Set_Edit

// XC_[̍쐬
HWND Set_Slider(HWND hParent, CSIZE sz)
{
	static int k = 0;
	HWND hSlider = CreateWindowEx(0,
				TRACKBAR_CLASS,
				NULL,
				WS_CHILD | WS_TABSTOP | WS_VISIBLE | TBS_VERT | TBS_RIGHT | TBS_AUTOTICKS,
				sz.y, sz.x, sz.hgt, sz.wdh,
				hParent,
				(HMENU) 1684 + k++,
				GetModuleHandle(NULL),
				NULL);

	return (hSlider);
}// Set_Slider

// Xs̍쐬
// flag_VertFc^  1A^  0
HWND Set_Spin(HWND hParent, CSIZE sz, bool flag_Vert)
{
	UINT style;
	CSIZE sz_s;
	if(flag_Vert){
		style = UDS_HORZ;
		sz_s= Set_Csize(sz.y, sz.x, sz.hgt, 20);
	}
	else{
		style = UDS_ALIGNRIGHT;
		sz_s = Set_Csize(0, 0, 0, 0);
	}
	static int k = 0;
	HWND hSpin = CreateWindowEx(0,
				UPDOWN_CLASS,
				NULL,
				WS_CHILD | WS_TABSTOP | WS_VISIBLE | 
				UDS_ARROWKEYS | UDS_NOTHOUSANDS | 
				UDS_AUTOBUDDY | UDS_SETBUDDYINT | style,
				sz_s.x, sz_s.y, sz_s.wdh, sz_s.hgt,
				hParent,
				(HMENU) 1700 + k++,
				GetModuleHandle(NULL),
				NULL);

	return (hSpin);
}// Set_Spin

// `FbN{bNX̍쐬
HWND Set_CheckBox(HWND hParent, CSIZE sz, char *text)
{
	static int k = 0;
	HWND hCheck = CreateWindowEx(0,
				"BUTTON",
				text,
				WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX | BS_VCENTER,
				0, 0, 0, 0,
				hParent,
				(HMENU) 1716 + k++,
				GetModuleHandle(NULL),
				NULL);
	
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL)
		SendMessage(hCheck, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
	// \ʒu̐ݒ
	if(sobj){
		SIZE size;
		size = Get_StrSize(hCheck, sobj, text);
		sz.y = (sz.hgt - size.cy) / 2;
		if(sz.y < 0)	sz.y = 0;
		MoveWindow(hCheck, sz.x, sz.y+1, size.cx+20, size.cy, FALSE);
	}
	
	return (hCheck);
}// Set_CheckBox

// y[W[̍쐬
// flag_VertFc^  1A^  0
HWND Set_Pager(HWND hWnd, bool flag_Vert)
{
	UINT style;
	if(flag_Vert){
		style = PGS_VERT;
	}
	else{
		style = PGS_HORZ;
	}
	static int k = 0;
	HWND hPager =   CreateWindowEx(0,
								WC_PAGESCROLLER,
								NULL,
								WS_CHILD |
								WS_VISIBLE |
								WS_CLIPCHILDREN |
								CCS_NODIVIDER | 
								style,
								0, 0, 0, 0,
								hWnd,
								(HMENU) 1732 + k++,
								GetModuleHandle(NULL),
								NULL);
	return (hPager);
}// Set_Pager

// R}hC𕪗
// FNameFR}hC
void Split_Filename(char *FName)
{
    char    *p = NULL;
    UINT    FN_len = 0;
	int		num_max = sizeof(filename2)/(MAX_PATH*sizeof(char));
    FN_ct = 0;
    while(FName != NULL){
        FN_len = strlen(FName);
        if(strcmp(&FName[FN_len-1],"\"") == 0){
            FName[FN_len-1] = '\0';
            p = strrchr(FName,'"');
            strcpy(filename2[FN_ct],p+1);
            *p = '\0';
            if(FName == NULL)
                break;
            else
                *(p-1) = '\0';
        }
        else{
            p = strrchr(FName,0x20);
            if(p == NULL){
                if(FName != NULL){
                    strcpy(filename2[FN_ct],FName);
                }
                break;
            }
            else{
                strcpy(filename2[FN_ct],p+1);
                *p = '\0';
            }
        }
        FN_ct ++;
		if(FN_ct >= num_max)
			break;
	}
	if(!strlen(filename2[0]))
		FN_ct = -1;
}// Split_Filename

// j[̃`FbNύX
bool Menu_Toggle_Check(UINT id)
{
	MENUITEMINFO    mi;
	
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	
	GetMenuItemInfo(g_hMenu,id,0,&mi);
	
	if(mi.fState == MFS_UNCHECKED)
		mi.fState = MFS_CHECKED;
	else
		mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(g_hMenu,id,0,&mi);
	
	if(mi.fState == MFS_CHECKED)
		return true;
	return false;
}// Menu_Toggle_Check

// j[ACe`FbNi܂͊Oj
void Menu_Check(HMENU hMenu, UINT id, bool flag_check)
{
	MENUITEMINFO    mi;
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	if(flag_check)
		mi.fState = MFS_CHECKED;
	else
		mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(hMenu,id,0,&mi);
}// Menu_Check

CSIZE Set_Csize(int x, int y, int wdh, int hgt)
{
	CSIZE sz;
	sz.x   = x;
	sz.y   = y;
	sz.wdh = wdh;
	sz.hgt = hgt;
	return sz;
}// Set_Csize

SIZE Get_StrSize(HWND hWnd, HGDIOBJ sobj, char *str)
{
	HGDIOBJ sobj_pre;
	SIZE    size;
	HDC hDC = GetDC(hWnd);
	sobj_pre = SelectObject(hDC, sobj);
	GetTextExtentPoint32(hDC, str, strlen(str), &size);
	SelectObject(hDC, sobj_pre);
	DeleteObject(sobj);
	ReleaseDC(hWnd, hDC);
	return (size);
}// Get_StrSize

// o[oh\ł΁Atrue Ԃ
// hRebar	F[IN] o[̃nh
// index	F[IN] oh̔ԍ
// ߂l	F\true, \false
bool IsVisible_Band(HWND hRebar, int index)
{
	REBARBANDINFO rbbi;
	ZeroMemory(&rbbi, sizeof(REBARBANDINFO));
	rbbi.cbSize = sizeof(REBARBANDINFO);
	rbbi.fMask = RBBIM_STYLE;
	SendMessage(hRebar, RB_GETBANDINFO, index, (LPARAM) &rbbi);
	if(rbbi.fStyle & RBBS_HIDDEN){
		return false;
	}
	return true;
}// IsVisible_Band

// _CAÕXg{bNX̃ACe
// new_pos : ւ̈ʒui-1:O, 0:ʒu, 1:1j
void Change_ListBoxItem(HWND hDlg, int id_list, int new_pos)
{
	int item_ct = SendDlgItemMessage(hDlg,id_list,LB_GETCOUNT,0,0);
	int index   = SendDlgItemMessage(hDlg,id_list,LB_GETCURSEL,0,0);
	if(index+new_pos < 0 || index+new_pos >= item_ct)
		return;
	char s[256];
	SendDlgItemMessage(hDlg,id_list,LB_GETTEXT,index,(LPARAM)s);
	int iItemData = SendDlgItemMessage(hDlg,id_list,LB_GETITEMDATA,index,0);
	SendDlgItemMessage(hDlg,id_list,LB_DELETESTRING,index,0);
	SendDlgItemMessage(hDlg,id_list,LB_INSERTSTRING,index+new_pos,(LPARAM) s);
	SendDlgItemMessage(hDlg,id_list,LB_SETITEMDATA,index+new_pos,iItemData);
	SendDlgItemMessage(hDlg,id_list,LB_SETCURSEL,index+new_pos,0);
}// Change_ListBoxItem

// _CAÕXg{bNX̌ݑIĂACe폜
void Delete_ListBoxItem(HWND hDlg, int id_list)
{
	int index = SendDlgItemMessage(hDlg,id_list,LB_GETCURSEL,0,0);
	if(index != LB_ERR){
		SendDlgItemMessage(hDlg,id_list,LB_DELETESTRING,index,0);
		int item_ct = SendDlgItemMessage(hDlg,id_list,LB_GETCOUNT,0,0);
		if(index >= item_ct){
			index = item_ct -1;
		}
		if(item_ct > 0){
			SendDlgItemMessage(hDlg,id_list,LB_SETCURSEL,index,0);
		}
	}
}// Delete_ListBoxItem
