// Bresenham ̐ASY

void Bre_Line(Graphics *g, int x1, int y1, int x2, int y2, Bitmap *BmpDot);
void Bre_Line_Sub(Graphics *g, int dx, int dy, int x1, int y1, int x2, int y2, Bitmap *BmpDot, bool bSteepSlant);
void Bre_Write_Pixel(Graphics *g, int x, int y, Bitmap *BmpDot, bool bSteepSlant);

// x1,y1Fn_̍WAx2,y2FI_̍WAclrFF
void Bre_Line(Graphics *g, int x1, int y1, int x2, int y2, Bitmap *BmpDot)
{
	int dx,dy;
	
	dx = abs(x2 - x1);
	dy = abs(y2 - y1);
	
	if(dx >= dy){
		Bre_Line_Sub(g, dx, dy, x1, y1, x2, y2, BmpDot, true);
	}
	else{
		Bre_Line_Sub(g, dy, dx, y1, x1, y2, x2, BmpDot, false);
	}
}// Bre_Line

void Bre_Line_Sub(Graphics *g, int dx, int dy, int x1, int y1, int x2, int y2, Bitmap *BmpDot, bool bSteepSlant)
{
	int d,x,y,xend,i1,i2,iy;
	
	i1 = 2 * dy;
	i2 = 2 * (dy - dx);
	d = i1 - dx;
	if((x1 <= x2 && y1 <= y2) || (x1 >= x2 && y1 >= y2)){
		iy = 1;
	}
	else{
		iy = -1;
	}
	if(x1 > x2){
		x = x2;
		y = y2;
		xend = x1;
	}
	else{
		x = x1;
		y = y1;
		xend = x2;
	}
	Bre_Write_Pixel(g, x, y, BmpDot, bSteepSlant);
	while(x < xend){
		x ++;
		if(d < 0){
			d += i1;
		}
		else{
			y += iy;
			d += i2;
		}
		Bre_Write_Pixel(g, x, y, BmpDot, bSteepSlant);
	}
}// Bre_Line_Sub

void Bre_Write_Pixel(Graphics *g, int x, int y, Bitmap *BmpDot, bool bSteepSlant)
{
	int x2,y2;
	
	if(bSteepSlant){
		x2 = x;
		y2 = y;
	}
	else{
		x2 = y;
		y2 = x;
	}
	int wdh = BmpDot->GetWidth();
	int	hgt = BmpDot->GetHeight();
	g->DrawImage(BmpDot, x2 - wdh/ 2, y2 - hgt / 2, wdh, hgt);
}// Bre_Write_Pixel
