// Bresenham ̐ASYic[pj

typedef struct{
	Point	*pos;
	int		pos_num;
}SPE,*LPSPE;

SPE	g_Spe = {0};

void Bre_Line_Spe(int x1, int y1, int x2, int y2);
void Bre_Line_Spe_Sub(int dx, int dy, int x1, int y1, int x2, int y2, bool bSteepSlant);
void Bre_Set_Pos_Spe(int x, int y, bool bSteepSlant);
void Bre_Spe_Term();

// x1,y1Fn_̍WAx2,y2FI_̍WAclrFF
void Bre_Line_Spe(int x1, int y1, int x2, int y2)
{
	int dx,dy;
	
	dx = abs(x2 - x1);
	dy = abs(y2 - y1);
	
	Bre_Spe_Term();
	g_Spe.pos = (Point*) malloc(32 * sizeof(Point));
	
	if(dx >= dy){
		Bre_Line_Spe_Sub(dx, dy, x1, y1, x2, y2, true);
	}
	else{
		Bre_Line_Spe_Sub(dy, dx, y1, x1, y2, x2, false);
	}
	
	// t
	if( (x1 > x2 && y1 <= y2 && dx > dy) || 
		(x1 > x2 && y1 >= y2 && dx > dy) || 
		(x1 >= x2 && y1 > y2 && dx <= dy) || 
		(x1 <= x2 && y1 > y2 && dx <= dy) )
	{
		Point	pt;
		for(int i=0;i<g_Spe.pos_num / 2;i++){
			pt = g_Spe.pos[g_Spe.pos_num-1-i];
			g_Spe.pos[g_Spe.pos_num-1-i] = g_Spe.pos[i];
			g_Spe.pos[i] = pt;
		}
	}
}// Bre_Line_Spe

void Bre_Line_Spe_Sub(int dx, int dy, int x1, int y1, int x2, int y2, bool bSteepSlant)
{
	int d,x,y,xend,i1,i2,iy;
	
	i1 = 2 * dy;
	i2 = 2 * (dy - dx);
	d = i1 - dx;
	if((x1 <= x2 && y1 <= y2) || (x1 >= x2 && y1 >= y2)){
		iy = 1;
	}
	else{
		iy = -1;
	}
	if(x1 > x2){
		x = x2;
		y = y2;
		xend = x1;
	}
	else{
		x = x1;
		y = y1;
		xend = x2;
	}
	Bre_Set_Pos_Spe(x, y, bSteepSlant);
	while(x < xend){
		x ++;
		if(d < 0){
			d += i1;
		}
		else{
			y += iy;
			d += i2;
		}
		Bre_Set_Pos_Spe(x, y, bSteepSlant);
	}
}// Bre_Line_Spe_Sub_X

void Bre_Set_Pos_Spe(int x, int y, bool bSteepSlant)
{
	int x2,y2;
	
	if(bSteepSlant){
		x2 = x;
		y2 = y;
	}
	else{
		x2 = y;
		y2 = x;
	}
	g_Spe.pos[g_Spe.pos_num].X = x2;
	g_Spe.pos[g_Spe.pos_num].Y = y2;
	g_Spe.pos_num ++;
	
	size_t size = _msize(g_Spe.pos);
	if(g_Spe.pos_num * sizeof(Point) >= size){
		g_Spe.pos = (Point*)realloc(g_Spe.pos, size+32*sizeof(Point));
	}
}// Bre_Set_Pos_Spe

void Bre_Spe_Term()
{
	FREE(g_Spe.pos);
	g_Spe.pos_num = 0;
}// Bre_Spe_Term
