void Set_ClrBox(bool flag_vert, HWND *hPal, HWND hParent, int num1, int num2, int x, int y, int wdh, int hgt, int dy);
Status Change_ClrBox(HWND hPic, HBITMAP *hBmp, COLORREF rgb, bool flag_frame, bool flag_cross);


// FI{bNX܂͏cɈ쐬
// flag_vertFcTRUE,FALSEAnum1Fz̎n܂Anum2Fz̏IAdyF{bNX̊Ԋu
void Set_ClrBox(bool flag_vert, HWND *hPal, HWND hParent, int num1, int num2, int x, int y, int wdh, int hgt, int dy)
{
	RECT rc;
	int  i;

	for(i=num1;i<num2;i++){
		if(flag_vert){
			rc.left   = x;
			rc.top    = (hgt + dy) * (i - num1) + y;
			rc.right  = hgt;
			rc.bottom = wdh;
		}
		else{
			rc.left   = (wdh + dy) * (i - num1) + x;
			rc.top    = y;
			rc.right  = wdh;
			rc.bottom = hgt;
		}
		static int k = 0;
		hPal[i] = CreateWindowEx(WS_EX_CLIENTEDGE,
					"STATIC",
					"",
					WS_CHILD | WS_VISIBLE | 
					SS_BITMAP | SS_NOTIFY,
					rc.left, rc.top, rc.right, rc.bottom,
					hParent,
					(HMENU)1456+k++,
					GetModuleHandle(NULL),
					NULL);
	}
}// Set_ClrBox

// J[{bNX̐FύX
// flag_frame : gtTRUE  gȂFALSE
// flag_cross : ~tTRUE  ~ȂFALSE
Status Change_ClrBox(HWND hPic, HBITMAP *hBmp, COLORREF rgb, bool flag_frame, bool flag_cross)
{
	Status		st = GenericError;
	Color		clr1,clr2;
	UINT		clr_add;
	BitmapData	bitmapData;
	int			wdh,hgt;
	RECT rc;
	GetClientRect(hPic, &rc);
	wdh = rc.right;
	hgt = rc.bottom;
	Rect		rect(0, 0, wdh, hgt);

	clr1 = RefToColor(rgb);
	clr_add = GetRValue(rgb)+GetGValue(rgb)+GetBValue(rgb);
	if(clr_add >= 0x180)
		clr2 = RefToColor(RGB(0,0,0));
	else
		clr2 = RefToColor(RGB(255,255,255));

	Bitmap Bmp (wdh, hgt, PixelFormat24bppRGB);
	if(Bmp.GetLastStatus() != Ok){
		MessageBox(GetFocus(),"Bmp쐬ł܂","",MB_OK);
		return st;
	}

	st = Bmp.LockBits(&rect, ImageLockModeWrite, PixelFormat24bppRGB, &bitmapData);
	if (st == Ok)
	{
		BYTE	*pixels1 = NULL;
		int		x,y;
		
		if (bitmapData.Stride > 0)
			pixels1 = (BYTE*) bitmapData.Scan0;
		else
			pixels1 = (BYTE*) bitmapData.Scan0
					+ (bitmapData.Stride)*(bitmapData.Height-1);
		int stride1 = abs(bitmapData.Stride);
		
		for(y=0;y<hgt;y++){
			for(x=0;x<wdh;x++){
				if( (flag_frame && (x<2 || x>wdh-3 || y<2 || y>hgt-3)) || 
					(flag_cross && (x == y || x == hgt - y - 1)))
				{
					pixels1[y*stride1+x*3+0] = (BYTE)(clr2.GetValue());
					pixels1[y*stride1+x*3+1] = (BYTE)(clr2.GetValue() >> 8);
					pixels1[y*stride1+x*3+2] = (BYTE)(clr2.GetValue() >> 16);
				}
				else{
					pixels1[y*stride1+x*3+0] = (BYTE)(clr1.GetValue());
					pixels1[y*stride1+x*3+1] = (BYTE)(clr1.GetValue() >> 8);
					pixels1[y*stride1+x*3+2] = (BYTE)(clr1.GetValue() >> 16);
				}
			}
		}
		st = Bmp.UnlockBits(&bitmapData);
		if(st != Ok){
			MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
			return st;
		}
	}
	else{
		MessageBox(GetFocus(),"BmpbNł܂","",MB_OK);
		return st;
	}
	
	Bmp.GetHBITMAP(NULL,hBmp);
	HBITMAP hbm;
	if(*hBmp)
		hbm = (HBITMAP) SendMessage(hPic, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM) *hBmp);
	if(hbm)	DeleteObject(hbm);
	return st;
}// Change_ClrBox
