typedef struct
{
	RECT	rect;	// Ƃ̗]
	POINT	size;	// 鎆̃TCY
}PRT,*LPPRT;

PRT	g_prt = {{2500,2500,2500,2500},{21000,29700}};

void PageSetup(HWND hWnd);
void Print(HWND hWnd, char *filename, Bitmap *Bmp, GraphicsPath *Path, int fillmode);

// ݒ_CAO
void PageSetup(HWND hWnd)
{
	PAGESETUPDLG	psd;
	int				r;
	
	ZeroMemory(&psd, sizeof(psd));
	psd.lStructSize = sizeof(psd);
	psd.hwndOwner = hWnd;
	psd.hInstance = GetModuleHandle(NULL);
	psd.Flags = PSD_INHUNDREDTHSOFMILLIMETERS | PSD_MARGINS ;
	psd.rtMargin = g_prt.rect;
	r = PageSetupDlg(&psd);
	if (r) {
		g_prt.rect = psd.rtMargin;
		g_prt.size = psd.ptPaperSize;
	}
	if(psd.hDevMode)	GlobalFree (psd.hDevMode);
	if(psd.hDevNames)	GlobalFree (psd.hDevNames);
}// PageSetup

// _CAO
void Print(HWND hWnd, char *filename, Bitmap *Bmp, GraphicsPath *Path, int fillmode)
{
	if(!Bmp)	return;
	
	PRINTDLG	pd;
	DOCINFO 	di;
	int 		i,r;
	float		dpi_x,dpi_y;	// 摜1C`̃sNZ
	POINT		sz;				// pTCYisNZPʁj
	RECT		of;				// O㍶E̗]isNZPʁj
	Rect		srcRect;		// 摜̈ʒuƑ傫
	Rect		destRect;		// 摜̈ʒuƑ傫
	
	ZeroMemory(&pd, sizeof(pd));
	pd.lStructSize = sizeof(pd);
	pd.hwndOwner = hWnd;
	pd.hInstance = GetModuleHandle(NULL);
	pd.Flags = PD_ALLPAGES | PD_RETURNDC | PD_HIDEPRINTTOFILE;
	r = PrintDlg(&pd);
	if (r) {
		dpi_x = Bmp->GetHorizontalResolution();
		dpi_y = Bmp->GetVerticalResolution();
		sz.x      = (int)(g_prt.size.x * dpi_x / 2540);
		sz.y      = (int)(g_prt.size.y * dpi_y / 2540);
		of.left   = (int)(g_prt.rect.left * dpi_x / 2540);
		of.top    = (int)(g_prt.rect.top * dpi_y / 2540);
		of.right  = (int)(g_prt.rect.right * dpi_x / 2540);
		of.bottom = (int)(g_prt.rect.bottom * dpi_y / 2540);
		if(sz.x < 0)		sz.x = 0;
		if(sz.y < 0)		sz.y = 0;
		if(of.left < 0)		of.left = 0;
		if(of.top < 0)		of.top = 0;
		if(of.right < 0)	of.right = 0;
		if(of.bottom < 0)	of.bottom = 0;
		
		if(pd.Flags & PD_SELECTION){		// I͈͈
			if(Path){
				Path->SetFillMode((FillMode) fillmode);
				Path->GetBounds(&srcRect);	// GetBounds ͂P傫g
				srcRect.Width --;
				srcRect.Height --;
			}
			else{
				Set_Rect(&srcRect, 0, 0, Bmp->GetWidth(), Bmp->GetHeight());
			}
		}
		else{
			Set_Rect(&srcRect, 0, 0, Bmp->GetWidth(), Bmp->GetHeight());
		}
		
		if(sz.x < srcRect.Width + of.left + of.right){
			srcRect.Width = sz.x - of.left - of.right;
			if(srcRect.Width < 0)	srcRect.Width = 0;
		}
		if(sz.y < srcRect.Height + of.top + of.bottom){
			srcRect.Height = sz.y - of.top - of.bottom;
			if(srcRect.Height < 0)	srcRect.Height = 0;
		}
		
		Set_Rect(&destRect, of.left, of.top, srcRect.Width, srcRect.Height);
		
		ZeroMemory(&di, sizeof(di));
		di.cbSize = sizeof(di);
		di.lpszDocName = filename;
		StartDoc(pd.hDC, &di);
		for(i=0;i<pd.nCopies;i++){	// Rs[̖
			StartPage(pd.hDC);
			Graphics	g(pd.hDC);
			g.DrawImage(Bmp, destRect, srcRect.X, srcRect.Y, srcRect.Width, srcRect.Height, UnitPixel);
			EndPage(pd.hDC);
		}
		EndDoc(pd.hDC);
	}
	if(pd.hDC)			DeleteDC (pd.hDC);
	if(pd.hDevMode) 	GlobalFree (pd.hDevMode);
	if(pd.hDevNames)	GlobalFree (pd.hDevNames);
}// Print
